# swagger-java-client

Database Repository Container Service API
- API version: 1.1.0-alpha
  - Build date: 2023-02-12T11:48:18.502846+01:00[Europe/Vienna]

Service that manages the containers


*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>io.swagger</groupId>
  <artifactId>swagger-java-client</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-java-client:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/swagger-java-client-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.ContainerEndpointApi;

import java.io.File;
import java.util.*;

public class ContainerEndpointApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        ContainerEndpointApi apiInstance = new ContainerEndpointApi();
        ContainerCreateRequestDto body = new ContainerCreateRequestDto(); // ContainerCreateRequestDto | 
        try {
            ContainerBriefDto result = apiInstance.create1(body);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling ContainerEndpointApi#create1");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.ContainerEndpointApi;

import java.io.File;
import java.util.*;

public class ContainerEndpointApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        ContainerEndpointApi apiInstance = new ContainerEndpointApi();
        Long id = 789L; // Long | 
        try {
            Object result = apiInstance.delete1(id);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling ContainerEndpointApi#delete1");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.ContainerEndpointApi;

import java.io.File;
import java.util.*;

public class ContainerEndpointApiExample {

    public static void main(String[] args) {
        
        ContainerEndpointApi apiInstance = new ContainerEndpointApi();
        try {
            List<ContainerBriefDto> result = apiInstance.findAll1();
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling ContainerEndpointApi#findAll1");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.ContainerEndpointApi;

import java.io.File;
import java.util.*;

public class ContainerEndpointApiExample {

    public static void main(String[] args) {
        
        ContainerEndpointApi apiInstance = new ContainerEndpointApi();
        Long id = 789L; // Long | 
        try {
            ContainerDto result = apiInstance.findById1(id);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling ContainerEndpointApi#findById1");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.ContainerEndpointApi;

import java.io.File;
import java.util.*;

public class ContainerEndpointApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        ContainerEndpointApi apiInstance = new ContainerEndpointApi();
        ContainerChangeDto body = new ContainerChangeDto(); // ContainerChangeDto | 
        Long id = 789L; // Long | 
        try {
            ContainerBriefDto result = apiInstance.modify(body, id);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling ContainerEndpointApi#modify");
            e.printStackTrace();
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:9091*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ContainerEndpointApi* | [**create1**](docs/ContainerEndpointApi.md#create1) | **POST** /api/container | Create container
*ContainerEndpointApi* | [**delete1**](docs/ContainerEndpointApi.md#delete1) | **DELETE** /api/container/{id} | Delete some container
*ContainerEndpointApi* | [**findAll1**](docs/ContainerEndpointApi.md#findAll1) | **GET** /api/container | Find all containers
*ContainerEndpointApi* | [**findById1**](docs/ContainerEndpointApi.md#findById1) | **GET** /api/container/{id} | Find some container
*ContainerEndpointApi* | [**modify**](docs/ContainerEndpointApi.md#modify) | **PUT** /api/container/{id} | Modify some container
*ImageEndpointApi* | [**create**](docs/ImageEndpointApi.md#create) | **POST** /api/image | Create image
*ImageEndpointApi* | [**delete**](docs/ImageEndpointApi.md#delete) | **DELETE** /api/image/{id} | Delete some image
*ImageEndpointApi* | [**findAll**](docs/ImageEndpointApi.md#findAll) | **GET** /api/image | Find all images
*ImageEndpointApi* | [**findById**](docs/ImageEndpointApi.md#findById) | **GET** /api/image/{id} | Find some image
*ImageEndpointApi* | [**update**](docs/ImageEndpointApi.md#update) | **PUT** /api/image/{id} | Update some image

## Documentation for Models

 - [ApiErrorDto](docs/ApiErrorDto.md)
 - [ContainerBriefDto](docs/ContainerBriefDto.md)
 - [ContainerChangeDto](docs/ContainerChangeDto.md)
 - [ContainerCreateRequestDto](docs/ContainerCreateRequestDto.md)
 - [ContainerDto](docs/ContainerDto.md)
 - [CreatorDto](docs/CreatorDto.md)
 - [DatabaseAccessDto](docs/DatabaseAccessDto.md)
 - [DatabaseDto](docs/DatabaseDto.md)
 - [GrantedAuthorityDto](docs/GrantedAuthorityDto.md)
 - [IdentifierDto](docs/IdentifierDto.md)
 - [ImageBriefDto](docs/ImageBriefDto.md)
 - [ImageChangeDto](docs/ImageChangeDto.md)
 - [ImageCreateDto](docs/ImageCreateDto.md)
 - [ImageDateDto](docs/ImageDateDto.md)
 - [ImageDto](docs/ImageDto.md)
 - [ImageEnvItemDto](docs/ImageEnvItemDto.md)
 - [LicenseDto](docs/LicenseDto.md)
 - [RelatedIdentifierDto](docs/RelatedIdentifierDto.md)
 - [TableBriefDto](docs/TableBriefDto.md)
 - [UserBriefDto](docs/UserBriefDto.md)
 - [UserDto](docs/UserDto.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### bearerAuth



## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author

andreas.rauber@tuwien.ac.at
