/*
 * Database Repository Query Service API
 * Service that manages the queries
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.ApiErrorDto;
import io.swagger.client.model.ExecuteStatementDto;
import io.swagger.client.model.QueryResultDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class QueryEndpointApi {
    private ApiClient apiClient;

    public QueryEndpointApi() {
        this(Configuration.getDefaultApiClient());
    }

    public QueryEndpointApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for execute
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call executeCall(ExecuteStatementDto body, Long id, Long databaseId, Long page, Long size, String sortDirection, String sortColumn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/query"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (size != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("size", size));
        if (sortDirection != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortDirection", sortDirection));
        if (sortColumn != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortColumn", sortColumn));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call executeValidateBeforeCall(ExecuteStatementDto body, Long id, Long databaseId, Long page, Long size, String sortDirection, String sortColumn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling execute(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling execute(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling execute(Async)");
        }
        
        com.squareup.okhttp.Call call = executeCall(body, id, databaseId, page, size, sortDirection, sortColumn, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Execute query
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @return QueryResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryResultDto execute(ExecuteStatementDto body, Long id, Long databaseId, Long page, Long size, String sortDirection, String sortColumn) throws ApiException {
        ApiResponse<QueryResultDto> resp = executeWithHttpInfo(body, id, databaseId, page, size, sortDirection, sortColumn);
        return resp.getData();
    }

    /**
     * Execute query
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @return ApiResponse&lt;QueryResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryResultDto> executeWithHttpInfo(ExecuteStatementDto body, Long id, Long databaseId, Long page, Long size, String sortDirection, String sortColumn) throws ApiException {
        com.squareup.okhttp.Call call = executeValidateBeforeCall(body, id, databaseId, page, size, sortDirection, sortColumn, null, null);
        Type localVarReturnType = new TypeToken<QueryResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Execute query (asynchronously)
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call executeAsync(ExecuteStatementDto body, Long id, Long databaseId, Long page, Long size, String sortDirection, String sortColumn, final ApiCallback<QueryResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = executeValidateBeforeCall(body, id, databaseId, page, size, sortDirection, sortColumn, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for export1
     * @param id  (required)
     * @param databaseId  (required)
     * @param queryId  (required)
     * @param accept  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call export1Call(Long id, Long databaseId, Long queryId, String accept, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/query/{queryId}/export"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()))
            .replaceAll("\\{" + "queryId" + "\\}", apiClient.escapeString(queryId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (accept != null)
        localVarHeaderParams.put("Accept", apiClient.parameterToString(accept));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call export1ValidateBeforeCall(Long id, Long databaseId, Long queryId, String accept, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling export1(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling export1(Async)");
        }
        // verify the required parameter 'queryId' is set
        if (queryId == null) {
            throw new ApiException("Missing the required parameter 'queryId' when calling export1(Async)");
        }
        // verify the required parameter 'accept' is set
        if (accept == null) {
            throw new ApiException("Missing the required parameter 'accept' when calling export1(Async)");
        }
        
        com.squareup.okhttp.Call call = export1Call(id, databaseId, queryId, accept, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Exports some query
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param queryId  (required)
     * @param accept  (required)
     * @return Object
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Object export1(Long id, Long databaseId, Long queryId, String accept) throws ApiException {
        ApiResponse<Object> resp = export1WithHttpInfo(id, databaseId, queryId, accept);
        return resp.getData();
    }

    /**
     * Exports some query
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param queryId  (required)
     * @param accept  (required)
     * @return ApiResponse&lt;Object&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Object> export1WithHttpInfo(Long id, Long databaseId, Long queryId, String accept) throws ApiException {
        com.squareup.okhttp.Call call = export1ValidateBeforeCall(id, databaseId, queryId, accept, null, null);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Exports some query (asynchronously)
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param queryId  (required)
     * @param accept  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call export1Async(Long id, Long databaseId, Long queryId, String accept, final ApiCallback<Object> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = export1ValidateBeforeCall(id, databaseId, queryId, accept, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Object>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for reExecute
     * @param id  (required)
     * @param databaseId  (required)
     * @param queryId  (required)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call reExecuteCall(Long id, Long databaseId, Long queryId, Long page, Long size, String sortDirection, String sortColumn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/query/{queryId}/data"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()))
            .replaceAll("\\{" + "queryId" + "\\}", apiClient.escapeString(queryId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (size != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("size", size));
        if (sortDirection != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortDirection", sortDirection));
        if (sortColumn != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortColumn", sortColumn));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call reExecuteValidateBeforeCall(Long id, Long databaseId, Long queryId, Long page, Long size, String sortDirection, String sortColumn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling reExecute(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling reExecute(Async)");
        }
        // verify the required parameter 'queryId' is set
        if (queryId == null) {
            throw new ApiException("Missing the required parameter 'queryId' when calling reExecute(Async)");
        }
        
        com.squareup.okhttp.Call call = reExecuteCall(id, databaseId, queryId, page, size, sortDirection, sortColumn, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Re-execute some query
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param queryId  (required)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @return QueryResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryResultDto reExecute(Long id, Long databaseId, Long queryId, Long page, Long size, String sortDirection, String sortColumn) throws ApiException {
        ApiResponse<QueryResultDto> resp = reExecuteWithHttpInfo(id, databaseId, queryId, page, size, sortDirection, sortColumn);
        return resp.getData();
    }

    /**
     * Re-execute some query
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param queryId  (required)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @return ApiResponse&lt;QueryResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryResultDto> reExecuteWithHttpInfo(Long id, Long databaseId, Long queryId, Long page, Long size, String sortDirection, String sortColumn) throws ApiException {
        com.squareup.okhttp.Call call = reExecuteValidateBeforeCall(id, databaseId, queryId, page, size, sortDirection, sortColumn, null, null);
        Type localVarReturnType = new TypeToken<QueryResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Re-execute some query (asynchronously)
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param queryId  (required)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call reExecuteAsync(Long id, Long databaseId, Long queryId, Long page, Long size, String sortDirection, String sortColumn, final ApiCallback<QueryResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = reExecuteValidateBeforeCall(id, databaseId, queryId, page, size, sortDirection, sortColumn, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
