/*
 * Database Repository Table Service API
 * Service that manages the tables
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.ApiErrorDto;
import io.swagger.client.model.ColumnDto;
import io.swagger.client.model.ColumnSemanticsUpdateDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TableColumnEndpointApi {
    private ApiClient apiClient;

    public TableColumnEndpointApi() {
        this(Configuration.getDefaultApiClient());
    }

    public TableColumnEndpointApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for update
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param columnId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateCall(ColumnSemanticsUpdateDto body, Long id, Long databaseId, Long tableId, Long columnId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/table/{tableId}/column/{columnId}"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()))
            .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()))
            .replaceAll("\\{" + "columnId" + "\\}", apiClient.escapeString(columnId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateValidateBeforeCall(ColumnSemanticsUpdateDto body, Long id, Long databaseId, Long tableId, Long columnId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling update(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling update(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling update(Async)");
        }
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling update(Async)");
        }
        // verify the required parameter 'columnId' is set
        if (columnId == null) {
            throw new ApiException("Missing the required parameter 'columnId' when calling update(Async)");
        }
        
        com.squareup.okhttp.Call call = updateCall(body, id, databaseId, tableId, columnId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Update a table column semantic mapping
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param columnId  (required)
     * @return ColumnDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ColumnDto update(ColumnSemanticsUpdateDto body, Long id, Long databaseId, Long tableId, Long columnId) throws ApiException {
        ApiResponse<ColumnDto> resp = updateWithHttpInfo(body, id, databaseId, tableId, columnId);
        return resp.getData();
    }

    /**
     * Update a table column semantic mapping
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param columnId  (required)
     * @return ApiResponse&lt;ColumnDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ColumnDto> updateWithHttpInfo(ColumnSemanticsUpdateDto body, Long id, Long databaseId, Long tableId, Long columnId) throws ApiException {
        com.squareup.okhttp.Call call = updateValidateBeforeCall(body, id, databaseId, tableId, columnId, null, null);
        Type localVarReturnType = new TypeToken<ColumnDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Update a table column semantic mapping (asynchronously)
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param columnId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateAsync(ColumnSemanticsUpdateDto body, Long id, Long databaseId, Long tableId, Long columnId, final ApiCallback<ColumnDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateValidateBeforeCall(body, id, databaseId, tableId, columnId, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ColumnDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
