/*
 * Database Repository Query Service API
 * Service that manages the queries
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.ApiErrorDto;
import io.swagger.client.model.ImportDto;
import org.threeten.bp.OffsetDateTime;
import io.swagger.client.model.QueryResultDto;
import io.swagger.client.model.TableCsvDeleteDto;
import io.swagger.client.model.TableCsvDto;
import io.swagger.client.model.TableCsvUpdateDto;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TableDataEndpointApi {
    private ApiClient apiClient;

    public TableDataEndpointApi() {
        this(Configuration.getDefaultApiClient());
    }

    public TableDataEndpointApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for delete1
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call delete1Call(TableCsvDeleteDto body, Long id, Long databaseId, Long tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/table/{tableId}/data"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()))
            .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call delete1ValidateBeforeCall(TableCsvDeleteDto body, Long id, Long databaseId, Long tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling delete1(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling delete1(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling delete1(Async)");
        }
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling delete1(Async)");
        }
        
        com.squareup.okhttp.Call call = delete1Call(body, id, databaseId, tableId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Delete data
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void delete1(TableCsvDeleteDto body, Long id, Long databaseId, Long tableId) throws ApiException {
        delete1WithHttpInfo(body, id, databaseId, tableId);
    }

    /**
     * Delete data
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> delete1WithHttpInfo(TableCsvDeleteDto body, Long id, Long databaseId, Long tableId) throws ApiException {
        com.squareup.okhttp.Call call = delete1ValidateBeforeCall(body, id, databaseId, tableId, null, null);
        return apiClient.execute(call);
    }

    /**
     * Delete data (asynchronously)
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call delete1Async(TableCsvDeleteDto body, Long id, Long databaseId, Long tableId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = delete1ValidateBeforeCall(body, id, databaseId, tableId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for getAll2
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param timestamp  (optional)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getAll2Call(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/table/{tableId}/data"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()))
            .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (timestamp != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("timestamp", timestamp));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (size != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("size", size));
        if (sortDirection != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortDirection", sortDirection));
        if (sortColumn != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortColumn", sortColumn));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "HEAD", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getAll2ValidateBeforeCall(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getAll2(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling getAll2(Async)");
        }
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling getAll2(Async)");
        }
        
        com.squareup.okhttp.Call call = getAll2Call(id, databaseId, tableId, timestamp, page, size, sortDirection, sortColumn, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Find data
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param timestamp  (optional)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @return QueryResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryResultDto getAll2(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn) throws ApiException {
        ApiResponse<QueryResultDto> resp = getAll2WithHttpInfo(id, databaseId, tableId, timestamp, page, size, sortDirection, sortColumn);
        return resp.getData();
    }

    /**
     * Find data
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param timestamp  (optional)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @return ApiResponse&lt;QueryResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryResultDto> getAll2WithHttpInfo(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn) throws ApiException {
        com.squareup.okhttp.Call call = getAll2ValidateBeforeCall(id, databaseId, tableId, timestamp, page, size, sortDirection, sortColumn, null, null);
        Type localVarReturnType = new TypeToken<QueryResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Find data (asynchronously)
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param timestamp  (optional)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getAll2Async(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn, final ApiCallback<QueryResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getAll2ValidateBeforeCall(id, databaseId, tableId, timestamp, page, size, sortDirection, sortColumn, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getAll3
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param timestamp  (optional)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getAll3Call(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/table/{tableId}/data"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()))
            .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (timestamp != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("timestamp", timestamp));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (size != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("size", size));
        if (sortDirection != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortDirection", sortDirection));
        if (sortColumn != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sortColumn", sortColumn));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getAll3ValidateBeforeCall(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling getAll3(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling getAll3(Async)");
        }
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling getAll3(Async)");
        }
        
        com.squareup.okhttp.Call call = getAll3Call(id, databaseId, tableId, timestamp, page, size, sortDirection, sortColumn, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Find data
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param timestamp  (optional)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @return QueryResultDto
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public QueryResultDto getAll3(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn) throws ApiException {
        ApiResponse<QueryResultDto> resp = getAll3WithHttpInfo(id, databaseId, tableId, timestamp, page, size, sortDirection, sortColumn);
        return resp.getData();
    }

    /**
     * Find data
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param timestamp  (optional)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @return ApiResponse&lt;QueryResultDto&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<QueryResultDto> getAll3WithHttpInfo(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn) throws ApiException {
        com.squareup.okhttp.Call call = getAll3ValidateBeforeCall(id, databaseId, tableId, timestamp, page, size, sortDirection, sortColumn, null, null);
        Type localVarReturnType = new TypeToken<QueryResultDto>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Find data (asynchronously)
     * 
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param timestamp  (optional)
     * @param page  (optional)
     * @param size  (optional)
     * @param sortDirection  (optional)
     * @param sortColumn  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getAll3Async(Long id, Long databaseId, Long tableId, OffsetDateTime timestamp, Long page, Long size, String sortDirection, String sortColumn, final ApiCallback<QueryResultDto> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getAll3ValidateBeforeCall(id, databaseId, tableId, timestamp, page, size, sortDirection, sortColumn, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<QueryResultDto>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for importCsv
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call importCsvCall(ImportDto body, Long id, Long databaseId, Long tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/table/{tableId}/data/import"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()))
            .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call importCsvValidateBeforeCall(ImportDto body, Long id, Long databaseId, Long tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling importCsv(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling importCsv(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling importCsv(Async)");
        }
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling importCsv(Async)");
        }
        
        com.squareup.okhttp.Call call = importCsvCall(body, id, databaseId, tableId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Insert data from csv
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void importCsv(ImportDto body, Long id, Long databaseId, Long tableId) throws ApiException {
        importCsvWithHttpInfo(body, id, databaseId, tableId);
    }

    /**
     * Insert data from csv
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> importCsvWithHttpInfo(ImportDto body, Long id, Long databaseId, Long tableId) throws ApiException {
        com.squareup.okhttp.Call call = importCsvValidateBeforeCall(body, id, databaseId, tableId, null, null);
        return apiClient.execute(call);
    }

    /**
     * Insert data from csv (asynchronously)
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call importCsvAsync(ImportDto body, Long id, Long databaseId, Long tableId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = importCsvValidateBeforeCall(body, id, databaseId, tableId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for insert
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call insertCall(TableCsvDto body, Long id, Long databaseId, Long tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/table/{tableId}/data"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()))
            .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call insertValidateBeforeCall(TableCsvDto body, Long id, Long databaseId, Long tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling insert(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling insert(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling insert(Async)");
        }
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling insert(Async)");
        }
        
        com.squareup.okhttp.Call call = insertCall(body, id, databaseId, tableId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Insert data
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void insert(TableCsvDto body, Long id, Long databaseId, Long tableId) throws ApiException {
        insertWithHttpInfo(body, id, databaseId, tableId);
    }

    /**
     * Insert data
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> insertWithHttpInfo(TableCsvDto body, Long id, Long databaseId, Long tableId) throws ApiException {
        com.squareup.okhttp.Call call = insertValidateBeforeCall(body, id, databaseId, tableId, null, null);
        return apiClient.execute(call);
    }

    /**
     * Insert data (asynchronously)
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call insertAsync(TableCsvDto body, Long id, Long databaseId, Long tableId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = insertValidateBeforeCall(body, id, databaseId, tableId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /**
     * Build call for update
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateCall(TableCsvUpdateDto body, Long id, Long databaseId, Long tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/api/container/{id}/database/{databaseId}/table/{tableId}/data"
            .replaceAll("\\{" + "id" + "\\}", apiClient.escapeString(id.toString()))
            .replaceAll("\\{" + "databaseId" + "\\}", apiClient.escapeString(databaseId.toString()))
            .replaceAll("\\{" + "tableId" + "\\}", apiClient.escapeString(tableId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "*/*"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateValidateBeforeCall(TableCsvUpdateDto body, Long id, Long databaseId, Long tableId, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling update(Async)");
        }
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling update(Async)");
        }
        // verify the required parameter 'databaseId' is set
        if (databaseId == null) {
            throw new ApiException("Missing the required parameter 'databaseId' when calling update(Async)");
        }
        // verify the required parameter 'tableId' is set
        if (tableId == null) {
            throw new ApiException("Missing the required parameter 'tableId' when calling update(Async)");
        }
        
        com.squareup.okhttp.Call call = updateCall(body, id, databaseId, tableId, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Update data
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void update(TableCsvUpdateDto body, Long id, Long databaseId, Long tableId) throws ApiException {
        updateWithHttpInfo(body, id, databaseId, tableId);
    }

    /**
     * Update data
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> updateWithHttpInfo(TableCsvUpdateDto body, Long id, Long databaseId, Long tableId) throws ApiException {
        com.squareup.okhttp.Call call = updateValidateBeforeCall(body, id, databaseId, tableId, null, null);
        return apiClient.execute(call);
    }

    /**
     * Update data (asynchronously)
     * 
     * @param body  (required)
     * @param id  (required)
     * @param databaseId  (required)
     * @param tableId  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateAsync(TableCsvUpdateDto body, Long id, Long databaseId, Long tableId, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateValidateBeforeCall(body, id, databaseId, tableId, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
