/*
 * Database Repository Container Service API
 * Service that manages the containers
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
/**
 * ApiErrorDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T11:48:18.502846+01:00[Europe/Vienna]")
public class ApiErrorDto {
  /**
   * Gets or Sets status
   */
  @JsonAdapter(StatusEnum.Adapter.class)
  public enum StatusEnum {
    _100_CONTINUE("100 CONTINUE"),
    _101_SWITCHING_PROTOCOLS("101 SWITCHING_PROTOCOLS"),
    _102_PROCESSING("102 PROCESSING"),
    _103_CHECKPOINT("103 CHECKPOINT"),
    _200_OK("200 OK"),
    _201_CREATED("201 CREATED"),
    _202_ACCEPTED("202 ACCEPTED"),
    _203_NON_AUTHORITATIVE_INFORMATION("203 NON_AUTHORITATIVE_INFORMATION"),
    _204_NO_CONTENT("204 NO_CONTENT"),
    _205_RESET_CONTENT("205 RESET_CONTENT"),
    _206_PARTIAL_CONTENT("206 PARTIAL_CONTENT"),
    _207_MULTI_STATUS("207 MULTI_STATUS"),
    _208_ALREADY_REPORTED("208 ALREADY_REPORTED"),
    _226_IM_USED("226 IM_USED"),
    _300_MULTIPLE_CHOICES("300 MULTIPLE_CHOICES"),
    _301_MOVED_PERMANENTLY("301 MOVED_PERMANENTLY"),
    _302_FOUND("302 FOUND"),
    _302_MOVED_TEMPORARILY("302 MOVED_TEMPORARILY"),
    _303_SEE_OTHER("303 SEE_OTHER"),
    _304_NOT_MODIFIED("304 NOT_MODIFIED"),
    _305_USE_PROXY("305 USE_PROXY"),
    _307_TEMPORARY_REDIRECT("307 TEMPORARY_REDIRECT"),
    _308_PERMANENT_REDIRECT("308 PERMANENT_REDIRECT"),
    _400_BAD_REQUEST("400 BAD_REQUEST"),
    _401_UNAUTHORIZED("401 UNAUTHORIZED"),
    _402_PAYMENT_REQUIRED("402 PAYMENT_REQUIRED"),
    _403_FORBIDDEN("403 FORBIDDEN"),
    _404_NOT_FOUND("404 NOT_FOUND"),
    _405_METHOD_NOT_ALLOWED("405 METHOD_NOT_ALLOWED"),
    _406_NOT_ACCEPTABLE("406 NOT_ACCEPTABLE"),
    _407_PROXY_AUTHENTICATION_REQUIRED("407 PROXY_AUTHENTICATION_REQUIRED"),
    _408_REQUEST_TIMEOUT("408 REQUEST_TIMEOUT"),
    _409_CONFLICT("409 CONFLICT"),
    _410_GONE("410 GONE"),
    _411_LENGTH_REQUIRED("411 LENGTH_REQUIRED"),
    _412_PRECONDITION_FAILED("412 PRECONDITION_FAILED"),
    _413_PAYLOAD_TOO_LARGE("413 PAYLOAD_TOO_LARGE"),
    _413_REQUEST_ENTITY_TOO_LARGE("413 REQUEST_ENTITY_TOO_LARGE"),
    _414_URI_TOO_LONG("414 URI_TOO_LONG"),
    _414_REQUEST_URI_TOO_LONG("414 REQUEST_URI_TOO_LONG"),
    _415_UNSUPPORTED_MEDIA_TYPE("415 UNSUPPORTED_MEDIA_TYPE"),
    _416_REQUESTED_RANGE_NOT_SATISFIABLE("416 REQUESTED_RANGE_NOT_SATISFIABLE"),
    _417_EXPECTATION_FAILED("417 EXPECTATION_FAILED"),
    _418_I_AM_A_TEAPOT("418 I_AM_A_TEAPOT"),
    _419_INSUFFICIENT_SPACE_ON_RESOURCE("419 INSUFFICIENT_SPACE_ON_RESOURCE"),
    _420_METHOD_FAILURE("420 METHOD_FAILURE"),
    _421_DESTINATION_LOCKED("421 DESTINATION_LOCKED"),
    _422_UNPROCESSABLE_ENTITY("422 UNPROCESSABLE_ENTITY"),
    _423_LOCKED("423 LOCKED"),
    _424_FAILED_DEPENDENCY("424 FAILED_DEPENDENCY"),
    _425_TOO_EARLY("425 TOO_EARLY"),
    _426_UPGRADE_REQUIRED("426 UPGRADE_REQUIRED"),
    _428_PRECONDITION_REQUIRED("428 PRECONDITION_REQUIRED"),
    _429_TOO_MANY_REQUESTS("429 TOO_MANY_REQUESTS"),
    _431_REQUEST_HEADER_FIELDS_TOO_LARGE("431 REQUEST_HEADER_FIELDS_TOO_LARGE"),
    _451_UNAVAILABLE_FOR_LEGAL_REASONS("451 UNAVAILABLE_FOR_LEGAL_REASONS"),
    _500_INTERNAL_SERVER_ERROR("500 INTERNAL_SERVER_ERROR"),
    _501_NOT_IMPLEMENTED("501 NOT_IMPLEMENTED"),
    _502_BAD_GATEWAY("502 BAD_GATEWAY"),
    _503_SERVICE_UNAVAILABLE("503 SERVICE_UNAVAILABLE"),
    _504_GATEWAY_TIMEOUT("504 GATEWAY_TIMEOUT"),
    _505_HTTP_VERSION_NOT_SUPPORTED("505 HTTP_VERSION_NOT_SUPPORTED"),
    _506_VARIANT_ALSO_NEGOTIATES("506 VARIANT_ALSO_NEGOTIATES"),
    _507_INSUFFICIENT_STORAGE("507 INSUFFICIENT_STORAGE"),
    _508_LOOP_DETECTED("508 LOOP_DETECTED"),
    _509_BANDWIDTH_LIMIT_EXCEEDED("509 BANDWIDTH_LIMIT_EXCEEDED"),
    _510_NOT_EXTENDED("510 NOT_EXTENDED"),
    _511_NETWORK_AUTHENTICATION_REQUIRED("511 NETWORK_AUTHENTICATION_REQUIRED");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static StatusEnum fromValue(String input) {
      for (StatusEnum b : StatusEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<StatusEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final StatusEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public StatusEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return StatusEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("status")
  private StatusEnum status = null;

  @SerializedName("message")
  private String message = null;

  @SerializedName("code")
  private String code = null;

  public ApiErrorDto status(StatusEnum status) {
    this.status = status;
    return this;
  }

   /**
   * Get status
   * @return status
  **/
  @Schema(example = "NOT_FOUND", required = true, description = "")
  public StatusEnum getStatus() {
    return status;
  }

  public void setStatus(StatusEnum status) {
    this.status = status;
  }

  public ApiErrorDto message(String message) {
    this.message = message;
    return this;
  }

   /**
   * Get message
   * @return message
  **/
  @Schema(example = "Could not find container", required = true, description = "")
  public String getMessage() {
    return message;
  }

  public void setMessage(String message) {
    this.message = message;
  }

  public ApiErrorDto code(String code) {
    this.code = code;
    return this;
  }

   /**
   * Get code
   * @return code
  **/
  @Schema(example = "error.container.notfound", required = true, description = "")
  public String getCode() {
    return code;
  }

  public void setCode(String code) {
    this.code = code;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ApiErrorDto apiErrorDto = (ApiErrorDto) o;
    return Objects.equals(this.status, apiErrorDto.status) &&
        Objects.equals(this.message, apiErrorDto.message) &&
        Objects.equals(this.code, apiErrorDto.code);
  }

  @Override
  public int hashCode() {
    return Objects.hash(status, message, code);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ApiErrorDto {\n");
    
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    code: ").append(toIndentedString(code)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
