/*
 * Database Repository Table Service API
 * Service that manages the tables
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * ColumnCreateDto
 */

public class ColumnCreateDto {
  @SerializedName("name")
  private String name = null;

  /**
   * Gets or Sets type
   */
  @JsonAdapter(TypeEnum.Adapter.class)
  public enum TypeEnum {
    ENUM("enum"),
    NUMBER("number"),
    DECIMAL("decimal"),
    STRING("string"),
    TEXT("text"),
    BOOLEAN("boolean"),
    DATE("date"),
    TIMESTAMP("timestamp"),
    BLOB("blob");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static TypeEnum fromValue(String input) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<TypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public TypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return TypeEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("dfid")
  private Long dfid = null;

  @SerializedName("unique")
  private Boolean unique = null;

  @SerializedName("references")
  private String references = null;

  @SerializedName("primary_key")
  private Boolean primaryKey = null;

  @SerializedName("null_allowed")
  private Boolean nullAllowed = null;

  @SerializedName("check_expression")
  private String checkExpression = null;

  @SerializedName("foreign_key")
  private String foreignKey = null;

  @SerializedName("enum_values")
  private List<String> enumValues = null;

  public ColumnCreateDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @Schema(example = "Date", required = true, description = "")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ColumnCreateDto type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @Schema(example = "string", required = true, description = "")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public ColumnCreateDto dfid(Long dfid) {
    this.dfid = dfid;
    return this;
  }

   /**
   * date format id
   * @return dfid
  **/
  @Schema(description = "date format id")
  public Long getDfid() {
    return dfid;
  }

  public void setDfid(Long dfid) {
    this.dfid = dfid;
  }

  public ColumnCreateDto unique(Boolean unique) {
    this.unique = unique;
    return this;
  }

   /**
   * Get unique
   * @return unique
  **/
  @Schema(example = "false", required = true, description = "")
  public Boolean isUnique() {
    return unique;
  }

  public void setUnique(Boolean unique) {
    this.unique = unique;
  }

  public ColumnCreateDto references(String references) {
    this.references = references;
    return this;
  }

   /**
   * foreign key reference, only considered when foreignKey !&#x3D; null
   * @return references
  **/
  @Schema(description = "foreign key reference, only considered when foreignKey != null")
  public String getReferences() {
    return references;
  }

  public void setReferences(String references) {
    this.references = references;
  }

  public ColumnCreateDto primaryKey(Boolean primaryKey) {
    this.primaryKey = primaryKey;
    return this;
  }

   /**
   * Get primaryKey
   * @return primaryKey
  **/
  @Schema(example = "false", required = true, description = "")
  public Boolean isPrimaryKey() {
    return primaryKey;
  }

  public void setPrimaryKey(Boolean primaryKey) {
    this.primaryKey = primaryKey;
  }

  public ColumnCreateDto nullAllowed(Boolean nullAllowed) {
    this.nullAllowed = nullAllowed;
    return this;
  }

   /**
   * Get nullAllowed
   * @return nullAllowed
  **/
  @Schema(example = "true", required = true, description = "")
  public Boolean isNullAllowed() {
    return nullAllowed;
  }

  public void setNullAllowed(Boolean nullAllowed) {
    this.nullAllowed = nullAllowed;
  }

  public ColumnCreateDto checkExpression(String checkExpression) {
    this.checkExpression = checkExpression;
    return this;
  }

   /**
   * check constraint
   * @return checkExpression
  **/
  @Schema(example = "id > 0", description = "check constraint")
  public String getCheckExpression() {
    return checkExpression;
  }

  public void setCheckExpression(String checkExpression) {
    this.checkExpression = checkExpression;
  }

  public ColumnCreateDto foreignKey(String foreignKey) {
    this.foreignKey = foreignKey;
    return this;
  }

   /**
   * Get foreignKey
   * @return foreignKey
  **/
  @Schema(description = "")
  public String getForeignKey() {
    return foreignKey;
  }

  public void setForeignKey(String foreignKey) {
    this.foreignKey = foreignKey;
  }

  public ColumnCreateDto enumValues(List<String> enumValues) {
    this.enumValues = enumValues;
    return this;
  }

  public ColumnCreateDto addEnumValuesItem(String enumValuesItem) {
    if (this.enumValues == null) {
      this.enumValues = new ArrayList<String>();
    }
    this.enumValues.add(enumValuesItem);
    return this;
  }

   /**
   * enum values, only considered when type &#x3D; ENUM
   * @return enumValues
  **/
  @Schema(description = "enum values, only considered when type = ENUM")
  public List<String> getEnumValues() {
    return enumValues;
  }

  public void setEnumValues(List<String> enumValues) {
    this.enumValues = enumValues;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ColumnCreateDto columnCreateDto = (ColumnCreateDto) o;
    return Objects.equals(this.name, columnCreateDto.name) &&
        Objects.equals(this.type, columnCreateDto.type) &&
        Objects.equals(this.dfid, columnCreateDto.dfid) &&
        Objects.equals(this.unique, columnCreateDto.unique) &&
        Objects.equals(this.references, columnCreateDto.references) &&
        Objects.equals(this.primaryKey, columnCreateDto.primaryKey) &&
        Objects.equals(this.nullAllowed, columnCreateDto.nullAllowed) &&
        Objects.equals(this.checkExpression, columnCreateDto.checkExpression) &&
        Objects.equals(this.foreignKey, columnCreateDto.foreignKey) &&
        Objects.equals(this.enumValues, columnCreateDto.enumValues);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, type, dfid, unique, references, primaryKey, nullAllowed, checkExpression, foreignKey, enumValues);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ColumnCreateDto {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    dfid: ").append(toIndentedString(dfid)).append("\n");
    sb.append("    unique: ").append(toIndentedString(unique)).append("\n");
    sb.append("    references: ").append(toIndentedString(references)).append("\n");
    sb.append("    primaryKey: ").append(toIndentedString(primaryKey)).append("\n");
    sb.append("    nullAllowed: ").append(toIndentedString(nullAllowed)).append("\n");
    sb.append("    checkExpression: ").append(toIndentedString(checkExpression)).append("\n");
    sb.append("    foreignKey: ").append(toIndentedString(foreignKey)).append("\n");
    sb.append("    enumValues: ").append(toIndentedString(enumValues)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
