/*
 * Database Repository Table Service API
 * Service that manages the tables
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.ConceptDto;
import io.swagger.client.model.ImageDateDto;
import io.swagger.client.model.UnitDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * ColumnDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T12:29:06.419178+01:00[Europe/Vienna]")
public class ColumnDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("concept")
  private ConceptDto concept = null;

  @SerializedName("unit")
  private UnitDto unit = null;

  @SerializedName("unique")
  private Boolean unique = null;

  @SerializedName("references")
  private String references = null;

  @SerializedName("internal_name")
  private String internalName = null;

  @SerializedName("date_format")
  private ImageDateDto dateFormat = null;

  @SerializedName("auto_generated")
  private Boolean autoGenerated = null;

  @SerializedName("is_primary_key")
  private Boolean isPrimaryKey = null;

  /**
   * Gets or Sets columnType
   */
  @JsonAdapter(ColumnTypeEnum.Adapter.class)
  public enum ColumnTypeEnum {
    ENUM("enum"),
    NUMBER("number"),
    DECIMAL("decimal"),
    STRING("string"),
    TEXT("text"),
    BOOLEAN("boolean"),
    DATE("date"),
    TIMESTAMP("timestamp"),
    BLOB("blob");

    private String value;

    ColumnTypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static ColumnTypeEnum fromValue(String input) {
      for (ColumnTypeEnum b : ColumnTypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<ColumnTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ColumnTypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public ColumnTypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return ColumnTypeEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("column_type")
  private ColumnTypeEnum columnType = null;

  @SerializedName("is_null_allowed")
  private Boolean isNullAllowed = null;

  @SerializedName("check_expression")
  private String checkExpression = null;

  @SerializedName("foreign_key")
  private String foreignKey = null;

  @SerializedName("enum_values")
  private List<String> enumValues = null;

  public ColumnDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public ColumnDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @Schema(example = "Date", required = true, description = "")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ColumnDto concept(ConceptDto concept) {
    this.concept = concept;
    return this;
  }

   /**
   * Get concept
   * @return concept
  **/
  @Schema(description = "")
  public ConceptDto getConcept() {
    return concept;
  }

  public void setConcept(ConceptDto concept) {
    this.concept = concept;
  }

  public ColumnDto unit(UnitDto unit) {
    this.unit = unit;
    return this;
  }

   /**
   * Get unit
   * @return unit
  **/
  @Schema(description = "")
  public UnitDto getUnit() {
    return unit;
  }

  public void setUnit(UnitDto unit) {
    this.unit = unit;
  }

  public ColumnDto unique(Boolean unique) {
    this.unique = unique;
    return this;
  }

   /**
   * Get unique
   * @return unique
  **/
  @Schema(example = "true", required = true, description = "")
  public Boolean isUnique() {
    return unique;
  }

  public void setUnique(Boolean unique) {
    this.unique = unique;
  }

  public ColumnDto references(String references) {
    this.references = references;
    return this;
  }

   /**
   * Get references
   * @return references
  **/
  @Schema(description = "")
  public String getReferences() {
    return references;
  }

  public void setReferences(String references) {
    this.references = references;
  }

  public ColumnDto internalName(String internalName) {
    this.internalName = internalName;
    return this;
  }

   /**
   * Get internalName
   * @return internalName
  **/
  @Schema(example = "mdb_date", required = true, description = "")
  public String getInternalName() {
    return internalName;
  }

  public void setInternalName(String internalName) {
    this.internalName = internalName;
  }

  public ColumnDto dateFormat(ImageDateDto dateFormat) {
    this.dateFormat = dateFormat;
    return this;
  }

   /**
   * Get dateFormat
   * @return dateFormat
  **/
  @Schema(description = "")
  public ImageDateDto getDateFormat() {
    return dateFormat;
  }

  public void setDateFormat(ImageDateDto dateFormat) {
    this.dateFormat = dateFormat;
  }

  public ColumnDto autoGenerated(Boolean autoGenerated) {
    this.autoGenerated = autoGenerated;
    return this;
  }

   /**
   * Get autoGenerated
   * @return autoGenerated
  **/
  @Schema(example = "false", required = true, description = "")
  public Boolean isAutoGenerated() {
    return autoGenerated;
  }

  public void setAutoGenerated(Boolean autoGenerated) {
    this.autoGenerated = autoGenerated;
  }

  public ColumnDto isPrimaryKey(Boolean isPrimaryKey) {
    this.isPrimaryKey = isPrimaryKey;
    return this;
  }

   /**
   * Get isPrimaryKey
   * @return isPrimaryKey
  **/
  @Schema(example = "true", required = true, description = "")
  public Boolean isIsPrimaryKey() {
    return isPrimaryKey;
  }

  public void setIsPrimaryKey(Boolean isPrimaryKey) {
    this.isPrimaryKey = isPrimaryKey;
  }

  public ColumnDto columnType(ColumnTypeEnum columnType) {
    this.columnType = columnType;
    return this;
  }

   /**
   * Get columnType
   * @return columnType
  **/
  @Schema(example = "string", required = true, description = "")
  public ColumnTypeEnum getColumnType() {
    return columnType;
  }

  public void setColumnType(ColumnTypeEnum columnType) {
    this.columnType = columnType;
  }

  public ColumnDto isNullAllowed(Boolean isNullAllowed) {
    this.isNullAllowed = isNullAllowed;
    return this;
  }

   /**
   * Get isNullAllowed
   * @return isNullAllowed
  **/
  @Schema(example = "false", required = true, description = "")
  public Boolean isIsNullAllowed() {
    return isNullAllowed;
  }

  public void setIsNullAllowed(Boolean isNullAllowed) {
    this.isNullAllowed = isNullAllowed;
  }

  public ColumnDto checkExpression(String checkExpression) {
    this.checkExpression = checkExpression;
    return this;
  }

   /**
   * Get checkExpression
   * @return checkExpression
  **/
  @Schema(description = "")
  public String getCheckExpression() {
    return checkExpression;
  }

  public void setCheckExpression(String checkExpression) {
    this.checkExpression = checkExpression;
  }

  public ColumnDto foreignKey(String foreignKey) {
    this.foreignKey = foreignKey;
    return this;
  }

   /**
   * Get foreignKey
   * @return foreignKey
  **/
  @Schema(description = "")
  public String getForeignKey() {
    return foreignKey;
  }

  public void setForeignKey(String foreignKey) {
    this.foreignKey = foreignKey;
  }

  public ColumnDto enumValues(List<String> enumValues) {
    this.enumValues = enumValues;
    return this;
  }

  public ColumnDto addEnumValuesItem(String enumValuesItem) {
    if (this.enumValues == null) {
      this.enumValues = new ArrayList<String>();
    }
    this.enumValues.add(enumValuesItem);
    return this;
  }

   /**
   * Get enumValues
   * @return enumValues
  **/
  @Schema(description = "")
  public List<String> getEnumValues() {
    return enumValues;
  }

  public void setEnumValues(List<String> enumValues) {
    this.enumValues = enumValues;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ColumnDto columnDto = (ColumnDto) o;
    return Objects.equals(this.id, columnDto.id) &&
        Objects.equals(this.name, columnDto.name) &&
        Objects.equals(this.concept, columnDto.concept) &&
        Objects.equals(this.unit, columnDto.unit) &&
        Objects.equals(this.unique, columnDto.unique) &&
        Objects.equals(this.references, columnDto.references) &&
        Objects.equals(this.internalName, columnDto.internalName) &&
        Objects.equals(this.dateFormat, columnDto.dateFormat) &&
        Objects.equals(this.autoGenerated, columnDto.autoGenerated) &&
        Objects.equals(this.isPrimaryKey, columnDto.isPrimaryKey) &&
        Objects.equals(this.columnType, columnDto.columnType) &&
        Objects.equals(this.isNullAllowed, columnDto.isNullAllowed) &&
        Objects.equals(this.checkExpression, columnDto.checkExpression) &&
        Objects.equals(this.foreignKey, columnDto.foreignKey) &&
        Objects.equals(this.enumValues, columnDto.enumValues);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, concept, unit, unique, references, internalName, dateFormat, autoGenerated, isPrimaryKey, columnType, isNullAllowed, checkExpression, foreignKey, enumValues);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ColumnDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    concept: ").append(toIndentedString(concept)).append("\n");
    sb.append("    unit: ").append(toIndentedString(unit)).append("\n");
    sb.append("    unique: ").append(toIndentedString(unique)).append("\n");
    sb.append("    references: ").append(toIndentedString(references)).append("\n");
    sb.append("    internalName: ").append(toIndentedString(internalName)).append("\n");
    sb.append("    dateFormat: ").append(toIndentedString(dateFormat)).append("\n");
    sb.append("    autoGenerated: ").append(toIndentedString(autoGenerated)).append("\n");
    sb.append("    isPrimaryKey: ").append(toIndentedString(isPrimaryKey)).append("\n");
    sb.append("    columnType: ").append(toIndentedString(columnType)).append("\n");
    sb.append("    isNullAllowed: ").append(toIndentedString(isNullAllowed)).append("\n");
    sb.append("    checkExpression: ").append(toIndentedString(checkExpression)).append("\n");
    sb.append("    foreignKey: ").append(toIndentedString(foreignKey)).append("\n");
    sb.append("    enumValues: ").append(toIndentedString(enumValues)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
