/*
 * Database Repository Database Service API
 * Service that manages the databases
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.v3.oas.annotations.media.Schema;
import org.threeten.bp.OffsetDateTime;

import java.util.Objects;
/**
 * DatabaseBriefDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T12:04:35.418127+01:00[Europe/Vienna]")
public class DatabaseBriefDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("identifier")
  private IdentifierDto identifier = null;

  @SerializedName("engine")
  private String engine = null;

  @SerializedName("container")
  private ContainerBriefDto container = null;

  @SerializedName("creator")
  private UserBriefDto creator = null;

  @SerializedName("created")
  private OffsetDateTime created = null;

  @SerializedName("is_public")
  private Boolean isPublic = null;

  public DatabaseBriefDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public DatabaseBriefDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @Schema(example = "Air Quality", required = true, description = "")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public DatabaseBriefDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Get description
   * @return description
  **/
  @Schema(example = "Air Quality in Austria", description = "")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public DatabaseBriefDto identifier(IdentifierDto identifier) {
    this.identifier = identifier;
    return this;
  }

   /**
   * Get identifier
   * @return identifier
  **/
  @Schema(description = "")
  public IdentifierDto getIdentifier() {
    return identifier;
  }

  public void setIdentifier(IdentifierDto identifier) {
    this.identifier = identifier;
  }

  public DatabaseBriefDto engine(String engine) {
    this.engine = engine;
    return this;
  }

   /**
   * Get engine
   * @return engine
  **/
  @Schema(example = "mariadb:10.5", description = "")
  public String getEngine() {
    return engine;
  }

  public void setEngine(String engine) {
    this.engine = engine;
  }

  public DatabaseBriefDto container(ContainerBriefDto container) {
    this.container = container;
    return this;
  }

   /**
   * Get container
   * @return container
  **/
  @Schema(description = "")
  public ContainerBriefDto getContainer() {
    return container;
  }

  public void setContainer(ContainerBriefDto container) {
    this.container = container;
  }

  public DatabaseBriefDto creator(UserBriefDto creator) {
    this.creator = creator;
    return this;
  }

   /**
   * Get creator
   * @return creator
  **/
  @Schema(description = "")
  public UserBriefDto getCreator() {
    return creator;
  }

  public void setCreator(UserBriefDto creator) {
    this.creator = creator;
  }

  public DatabaseBriefDto created(OffsetDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @Schema(description = "")
  public OffsetDateTime getCreated() {
    return created;
  }

  public void setCreated(OffsetDateTime created) {
    this.created = created;
  }

  public DatabaseBriefDto isPublic(Boolean isPublic) {
    this.isPublic = isPublic;
    return this;
  }

   /**
   * Get isPublic
   * @return isPublic
  **/
  @Schema(example = "true", description = "")
  public Boolean isIsPublic() {
    return isPublic;
  }

  public void setIsPublic(Boolean isPublic) {
    this.isPublic = isPublic;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DatabaseBriefDto databaseBriefDto = (DatabaseBriefDto) o;
    return Objects.equals(this.id, databaseBriefDto.id) &&
        Objects.equals(this.name, databaseBriefDto.name) &&
        Objects.equals(this.description, databaseBriefDto.description) &&
        Objects.equals(this.identifier, databaseBriefDto.identifier) &&
        Objects.equals(this.engine, databaseBriefDto.engine) &&
        Objects.equals(this.container, databaseBriefDto.container) &&
        Objects.equals(this.creator, databaseBriefDto.creator) &&
        Objects.equals(this.created, databaseBriefDto.created) &&
        Objects.equals(this.isPublic, databaseBriefDto.isPublic);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, description, identifier, engine, container, creator, created, isPublic);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DatabaseBriefDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    identifier: ").append(toIndentedString(identifier)).append("\n");
    sb.append("    engine: ").append(toIndentedString(engine)).append("\n");
    sb.append("    container: ").append(toIndentedString(container)).append("\n");
    sb.append("    creator: ").append(toIndentedString(creator)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    isPublic: ").append(toIndentedString(isPublic)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
