/*
 * Database Repository Container Service API
 * Service that manages the containers
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.ContainerDto;
import io.swagger.client.model.DatabaseAccessDto;
import io.swagger.client.model.IdentifierDto;
import io.swagger.client.model.ImageDto;
import io.swagger.client.model.TableBriefDto;
import io.swagger.client.model.UserBriefDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.threeten.bp.OffsetDateTime;
/**
 * DatabaseDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T11:48:18.502846+01:00[Europe/Vienna]")
public class DatabaseDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("creator")
  private UserBriefDto creator = null;

  @SerializedName("identifier")
  private IdentifierDto identifier = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("tables")
  private List<TableBriefDto> tables = null;

  @SerializedName("image")
  private ImageDto image = null;

  @SerializedName("container")
  private ContainerDto container = null;

  @SerializedName("accesses")
  private List<DatabaseAccessDto> accesses = null;

  @SerializedName("created")
  private OffsetDateTime created = null;

  @SerializedName("exchange_name")
  private String exchangeName = null;

  @SerializedName("internal_name")
  private String internalName = null;

  @SerializedName("is_public")
  private Boolean isPublic = null;

  public DatabaseDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public DatabaseDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @Schema(example = "Air Quality", required = true, description = "")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public DatabaseDto creator(UserBriefDto creator) {
    this.creator = creator;
    return this;
  }

   /**
   * Get creator
   * @return creator
  **/
  @Schema(required = true, description = "")
  public UserBriefDto getCreator() {
    return creator;
  }

  public void setCreator(UserBriefDto creator) {
    this.creator = creator;
  }

  public DatabaseDto identifier(IdentifierDto identifier) {
    this.identifier = identifier;
    return this;
  }

   /**
   * Get identifier
   * @return identifier
  **/
  @Schema(description = "")
  public IdentifierDto getIdentifier() {
    return identifier;
  }

  public void setIdentifier(IdentifierDto identifier) {
    this.identifier = identifier;
  }

  public DatabaseDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Get description
   * @return description
  **/
  @Schema(example = "Weather Australia 2009-2021", description = "")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public DatabaseDto tables(List<TableBriefDto> tables) {
    this.tables = tables;
    return this;
  }

  public DatabaseDto addTablesItem(TableBriefDto tablesItem) {
    if (this.tables == null) {
      this.tables = new ArrayList<TableBriefDto>();
    }
    this.tables.add(tablesItem);
    return this;
  }

   /**
   * Get tables
   * @return tables
  **/
  @Schema(description = "")
  public List<TableBriefDto> getTables() {
    return tables;
  }

  public void setTables(List<TableBriefDto> tables) {
    this.tables = tables;
  }

  public DatabaseDto image(ImageDto image) {
    this.image = image;
    return this;
  }

   /**
   * Get image
   * @return image
  **/
  @Schema(description = "")
  public ImageDto getImage() {
    return image;
  }

  public void setImage(ImageDto image) {
    this.image = image;
  }

  public DatabaseDto container(ContainerDto container) {
    this.container = container;
    return this;
  }

   /**
   * Get container
   * @return container
  **/
  @Schema(description = "")
  public ContainerDto getContainer() {
    return container;
  }

  public void setContainer(ContainerDto container) {
    this.container = container;
  }

  public DatabaseDto accesses(List<DatabaseAccessDto> accesses) {
    this.accesses = accesses;
    return this;
  }

  public DatabaseDto addAccessesItem(DatabaseAccessDto accessesItem) {
    if (this.accesses == null) {
      this.accesses = new ArrayList<DatabaseAccessDto>();
    }
    this.accesses.add(accessesItem);
    return this;
  }

   /**
   * Get accesses
   * @return accesses
  **/
  @Schema(description = "")
  public List<DatabaseAccessDto> getAccesses() {
    return accesses;
  }

  public void setAccesses(List<DatabaseAccessDto> accesses) {
    this.accesses = accesses;
  }

  public DatabaseDto created(OffsetDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @Schema(description = "")
  public OffsetDateTime getCreated() {
    return created;
  }

  public void setCreated(OffsetDateTime created) {
    this.created = created;
  }

  public DatabaseDto exchangeName(String exchangeName) {
    this.exchangeName = exchangeName;
    return this;
  }

   /**
   * Get exchangeName
   * @return exchangeName
  **/
  @Schema(example = "dbrepo/4/4", required = true, description = "")
  public String getExchangeName() {
    return exchangeName;
  }

  public void setExchangeName(String exchangeName) {
    this.exchangeName = exchangeName;
  }

  public DatabaseDto internalName(String internalName) {
    this.internalName = internalName;
    return this;
  }

   /**
   * Get internalName
   * @return internalName
  **/
  @Schema(example = "weather_australia", required = true, description = "")
  public String getInternalName() {
    return internalName;
  }

  public void setInternalName(String internalName) {
    this.internalName = internalName;
  }

  public DatabaseDto isPublic(Boolean isPublic) {
    this.isPublic = isPublic;
    return this;
  }

   /**
   * Get isPublic
   * @return isPublic
  **/
  @Schema(example = "true", description = "")
  public Boolean isIsPublic() {
    return isPublic;
  }

  public void setIsPublic(Boolean isPublic) {
    this.isPublic = isPublic;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DatabaseDto databaseDto = (DatabaseDto) o;
    return Objects.equals(this.id, databaseDto.id) &&
        Objects.equals(this.name, databaseDto.name) &&
        Objects.equals(this.creator, databaseDto.creator) &&
        Objects.equals(this.identifier, databaseDto.identifier) &&
        Objects.equals(this.description, databaseDto.description) &&
        Objects.equals(this.tables, databaseDto.tables) &&
        Objects.equals(this.image, databaseDto.image) &&
        Objects.equals(this.container, databaseDto.container) &&
        Objects.equals(this.accesses, databaseDto.accesses) &&
        Objects.equals(this.created, databaseDto.created) &&
        Objects.equals(this.exchangeName, databaseDto.exchangeName) &&
        Objects.equals(this.internalName, databaseDto.internalName) &&
        Objects.equals(this.isPublic, databaseDto.isPublic);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, creator, identifier, description, tables, image, container, accesses, created, exchangeName, internalName, isPublic);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DatabaseDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    creator: ").append(toIndentedString(creator)).append("\n");
    sb.append("    identifier: ").append(toIndentedString(identifier)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    tables: ").append(toIndentedString(tables)).append("\n");
    sb.append("    image: ").append(toIndentedString(image)).append("\n");
    sb.append("    container: ").append(toIndentedString(container)).append("\n");
    sb.append("    accesses: ").append(toIndentedString(accesses)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    exchangeName: ").append(toIndentedString(exchangeName)).append("\n");
    sb.append("    internalName: ").append(toIndentedString(internalName)).append("\n");
    sb.append("    isPublic: ").append(toIndentedString(isPublic)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
