/*
 * Database Repository Container Service API
 * Service that manages the containers
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.CreatorDto;
import io.swagger.client.model.LicenseDto;
import io.swagger.client.model.RelatedIdentifierDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.threeten.bp.OffsetDateTime;
/**
 * IdentifierDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T11:48:18.502846+01:00[Europe/Vienna]")
public class IdentifierDto {
  @SerializedName("id")
  private Long id = null;

  /**
   * Gets or Sets type
   */
  @JsonAdapter(TypeEnum.Adapter.class)
  public enum TypeEnum {
    DATABASE("database"),
    SUBSET("subset");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static TypeEnum fromValue(String input) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<TypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public TypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return TypeEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("title")
  private String title = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("query")
  private String query = null;

  @SerializedName("execution")
  private OffsetDateTime execution = null;

  /**
   * Gets or Sets visibility
   */
  @JsonAdapter(VisibilityEnum.Adapter.class)
  public enum VisibilityEnum {
    EVERYONE("everyone"),
    TRUSTED("trusted"),
    SELF("self");

    private String value;

    VisibilityEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static VisibilityEnum fromValue(String input) {
      for (VisibilityEnum b : VisibilityEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<VisibilityEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final VisibilityEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public VisibilityEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return VisibilityEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("visibility")
  private VisibilityEnum visibility = null;

  @SerializedName("doi")
  private String doi = null;

  @SerializedName("publisher")
  private String publisher = null;

  /**
   * Gets or Sets language
   */
  @JsonAdapter(LanguageEnum.Adapter.class)
  public enum LanguageEnum {
    AB("ab"),
    AA("aa"),
    AF("af"),
    AK("ak"),
    SQ("sq"),
    AM("am"),
    AR("ar"),
    AN("an"),
    HY("hy"),
    AS("as"),
    AV("av"),
    AE("ae"),
    AY("ay"),
    AZ("az"),
    BM("bm"),
    BA("ba"),
    EU("eu"),
    BE("be"),
    BN("bn"),
    BH("bh"),
    BI("bi"),
    BS("bs"),
    BR("br"),
    BG("bg"),
    MY("my"),
    CA("ca"),
    KM("km"),
    CH("ch"),
    CE("ce"),
    NY("ny"),
    ZH("zh"),
    CU("cu"),
    CV("cv"),
    KW("kw"),
    CO("co"),
    CR("cr"),
    HR("hr"),
    CS("cs"),
    DA("da"),
    DV("dv"),
    NL("nl"),
    DZ("dz"),
    EN("en"),
    EO("eo"),
    ET("et"),
    EE("ee"),
    FO("fo"),
    FJ("fj"),
    FI("fi"),
    FR("fr"),
    FF("ff"),
    GD("gd"),
    GL("gl"),
    LG("lg"),
    KA("ka"),
    DE("de"),
    KI("ki"),
    EL("el"),
    KL("kl"),
    GN("gn"),
    GU("gu"),
    HT("ht"),
    HA("ha"),
    HE("he"),
    HZ("hz"),
    HI("hi"),
    HO("ho"),
    HU("hu"),
    IS("is"),
    IO("io"),
    IG("ig"),
    ID("id"),
    IA("ia"),
    IE("ie"),
    IU("iu"),
    IK("ik"),
    GA("ga"),
    IT("it"),
    JA("ja"),
    JV("jv"),
    KN("kn"),
    KR("kr"),
    KS("ks"),
    KK("kk"),
    RW("rw"),
    KV("kv"),
    KG("kg"),
    KO("ko"),
    KJ("kj"),
    KU("ku"),
    KY("ky"),
    LO("lo"),
    LA("la"),
    LV("lv"),
    LB("lb"),
    LI("li"),
    LN("ln"),
    LT("lt"),
    LU("lu"),
    MK("mk"),
    MG("mg"),
    MS("ms"),
    ML("ml"),
    MT("mt"),
    GV("gv"),
    MI("mi"),
    MR("mr"),
    MH("mh"),
    RO("ro"),
    MN("mn"),
    NA("na"),
    NV("nv"),
    ND("nd"),
    NG("ng"),
    NE("ne"),
    SE("se"),
    NO("no"),
    NB("nb"),
    NN("nn"),
    II("ii"),
    OC("oc"),
    OJ("oj"),
    OR("or"),
    OM("om"),
    OS("os"),
    PI("pi"),
    PA("pa"),
    PS("ps"),
    FA("fa"),
    PL("pl"),
    PT("pt"),
    QU("qu"),
    RM("rm"),
    RN("rn"),
    RU("ru"),
    SM("sm"),
    SG("sg"),
    SA("sa"),
    SC("sc"),
    SR("sr"),
    SN("sn"),
    SD("sd"),
    SI("si"),
    SK("sk"),
    SL("sl"),
    SO("so"),
    ST("st"),
    NR("nr"),
    ES("es"),
    SU("su"),
    SW("sw"),
    SS("ss"),
    SV("sv"),
    TL("tl"),
    TY("ty"),
    TG("tg"),
    TA("ta"),
    TT("tt"),
    TE("te"),
    TH("th"),
    BO("bo"),
    TI("ti"),
    TO("to"),
    TS("ts"),
    TN("tn"),
    TR("tr"),
    TK("tk"),
    TW("tw"),
    UG("ug"),
    UK("uk"),
    UR("ur"),
    UZ("uz"),
    VE("ve"),
    VI("vi"),
    VO("vo"),
    WA("wa"),
    CY("cy"),
    FY("fy"),
    WO("wo"),
    XH("xh"),
    YI("yi"),
    YO("yo"),
    ZA("za"),
    ZU("zu");

    private String value;

    LanguageEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static LanguageEnum fromValue(String input) {
      for (LanguageEnum b : LanguageEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<LanguageEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final LanguageEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public LanguageEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return LanguageEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("language")
  private LanguageEnum language = null;

  @SerializedName("license")
  private LicenseDto license = null;

  @SerializedName("creators")
  private List<CreatorDto> creators = new ArrayList<CreatorDto>();

  @SerializedName("created")
  private OffsetDateTime created = null;

  @SerializedName("container id")
  private Long containerId = null;

  @SerializedName("database id")
  private Long databaseId = null;

  @SerializedName("query id")
  private Long queryId = null;

  @SerializedName("query_normalized")
  private String queryNormalized = null;

  @SerializedName("related")
  private List<RelatedIdentifierDto> related = null;

  @SerializedName("query_hash")
  private String queryHash = null;

  @SerializedName("result_hash")
  private String resultHash = null;

  @SerializedName("result_number")
  private Long resultNumber = null;

  @SerializedName("publication_day")
  private Integer publicationDay = null;

  @SerializedName("publication_month")
  private Integer publicationMonth = null;

  @SerializedName("publication_year")
  private Integer publicationYear = null;

  @SerializedName("last_modified")
  private OffsetDateTime lastModified = null;

  public IdentifierDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public IdentifierDto type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @Schema(required = true, description = "")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public IdentifierDto title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Get title
   * @return title
  **/
  @Schema(example = "Airquality Stephansplatz, Vienna, Austria", required = true, description = "")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public IdentifierDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Get description
   * @return description
  **/
  @Schema(example = "Air quality reports at Stephansplatz, Vienna", description = "")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public IdentifierDto query(String query) {
    this.query = query;
    return this;
  }

   /**
   * Get query
   * @return query
  **/
  @Schema(example = "SELECT `id`, `value`, `location` FROM `air_quality` WHERE `location` = \"09:STEF\"", required = true, description = "")
  public String getQuery() {
    return query;
  }

  public void setQuery(String query) {
    this.query = query;
  }

  public IdentifierDto execution(OffsetDateTime execution) {
    this.execution = execution;
    return this;
  }

   /**
   * Get execution
   * @return execution
  **/
  @Schema(required = true, description = "")
  public OffsetDateTime getExecution() {
    return execution;
  }

  public void setExecution(OffsetDateTime execution) {
    this.execution = execution;
  }

  public IdentifierDto visibility(VisibilityEnum visibility) {
    this.visibility = visibility;
    return this;
  }

   /**
   * Get visibility
   * @return visibility
  **/
  @Schema(example = "everyone", required = true, description = "")
  public VisibilityEnum getVisibility() {
    return visibility;
  }

  public void setVisibility(VisibilityEnum visibility) {
    this.visibility = visibility;
  }

  public IdentifierDto doi(String doi) {
    this.doi = doi;
    return this;
  }

   /**
   * Get doi
   * @return doi
  **/
  @Schema(example = "10.1038/nphys1170", description = "")
  public String getDoi() {
    return doi;
  }

  public void setDoi(String doi) {
    this.doi = doi;
  }

  public IdentifierDto publisher(String publisher) {
    this.publisher = publisher;
    return this;
  }

   /**
   * Get publisher
   * @return publisher
  **/
  @Schema(example = "TU Wien", description = "")
  public String getPublisher() {
    return publisher;
  }

  public void setPublisher(String publisher) {
    this.publisher = publisher;
  }

  public IdentifierDto language(LanguageEnum language) {
    this.language = language;
    return this;
  }

   /**
   * Get language
   * @return language
  **/
  @Schema(description = "")
  public LanguageEnum getLanguage() {
    return language;
  }

  public void setLanguage(LanguageEnum language) {
    this.language = language;
  }

  public IdentifierDto license(LicenseDto license) {
    this.license = license;
    return this;
  }

   /**
   * Get license
   * @return license
  **/
  @Schema(description = "")
  public LicenseDto getLicense() {
    return license;
  }

  public void setLicense(LicenseDto license) {
    this.license = license;
  }

  public IdentifierDto creators(List<CreatorDto> creators) {
    this.creators = creators;
    return this;
  }

  public IdentifierDto addCreatorsItem(CreatorDto creatorsItem) {
    this.creators.add(creatorsItem);
    return this;
  }

   /**
   * Get creators
   * @return creators
  **/
  @Schema(required = true, description = "")
  public List<CreatorDto> getCreators() {
    return creators;
  }

  public void setCreators(List<CreatorDto> creators) {
    this.creators = creators;
  }

  public IdentifierDto created(OffsetDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @Schema(description = "")
  public OffsetDateTime getCreated() {
    return created;
  }

  public void setCreated(OffsetDateTime created) {
    this.created = created;
  }

  public IdentifierDto containerId(Long containerId) {
    this.containerId = containerId;
    return this;
  }

   /**
   * Get containerId
   * @return containerId
  **/
  @Schema(example = "1", required = true, description = "")
  public Long getContainerId() {
    return containerId;
  }

  public void setContainerId(Long containerId) {
    this.containerId = containerId;
  }

  public IdentifierDto databaseId(Long databaseId) {
    this.databaseId = databaseId;
    return this;
  }

   /**
   * Get databaseId
   * @return databaseId
  **/
  @Schema(example = "1", required = true, description = "")
  public Long getDatabaseId() {
    return databaseId;
  }

  public void setDatabaseId(Long databaseId) {
    this.databaseId = databaseId;
  }

  public IdentifierDto queryId(Long queryId) {
    this.queryId = queryId;
    return this;
  }

   /**
   * Get queryId
   * @return queryId
  **/
  @Schema(example = "1", description = "")
  public Long getQueryId() {
    return queryId;
  }

  public void setQueryId(Long queryId) {
    this.queryId = queryId;
  }

  public IdentifierDto queryNormalized(String queryNormalized) {
    this.queryNormalized = queryNormalized;
    return this;
  }

   /**
   * Get queryNormalized
   * @return queryNormalized
  **/
  @Schema(example = "SELECT `id`, `value`, `location` FROM `air_quality` WHERE `location` = \"09:STEF\"", required = true, description = "")
  public String getQueryNormalized() {
    return queryNormalized;
  }

  public void setQueryNormalized(String queryNormalized) {
    this.queryNormalized = queryNormalized;
  }

  public IdentifierDto related(List<RelatedIdentifierDto> related) {
    this.related = related;
    return this;
  }

  public IdentifierDto addRelatedItem(RelatedIdentifierDto relatedItem) {
    if (this.related == null) {
      this.related = new ArrayList<RelatedIdentifierDto>();
    }
    this.related.add(relatedItem);
    return this;
  }

   /**
   * Get related
   * @return related
  **/
  @Schema(description = "")
  public List<RelatedIdentifierDto> getRelated() {
    return related;
  }

  public void setRelated(List<RelatedIdentifierDto> related) {
    this.related = related;
  }

  public IdentifierDto queryHash(String queryHash) {
    this.queryHash = queryHash;
    return this;
  }

   /**
   * query hash in sha512
   * @return queryHash
  **/
  @Schema(required = true, description = "query hash in sha512")
  public String getQueryHash() {
    return queryHash;
  }

  public void setQueryHash(String queryHash) {
    this.queryHash = queryHash;
  }

  public IdentifierDto resultHash(String resultHash) {
    this.resultHash = resultHash;
    return this;
  }

   /**
   * Get resultHash
   * @return resultHash
  **/
  @Schema(required = true, description = "")
  public String getResultHash() {
    return resultHash;
  }

  public void setResultHash(String resultHash) {
    this.resultHash = resultHash;
  }

  public IdentifierDto resultNumber(Long resultNumber) {
    this.resultNumber = resultNumber;
    return this;
  }

   /**
   * Get resultNumber
   * @return resultNumber
  **/
  @Schema(example = "1", required = true, description = "")
  public Long getResultNumber() {
    return resultNumber;
  }

  public void setResultNumber(Long resultNumber) {
    this.resultNumber = resultNumber;
  }

  public IdentifierDto publicationDay(Integer publicationDay) {
    this.publicationDay = publicationDay;
    return this;
  }

   /**
   * Get publicationDay
   * @return publicationDay
  **/
  @Schema(example = "15", description = "")
  public Integer getPublicationDay() {
    return publicationDay;
  }

  public void setPublicationDay(Integer publicationDay) {
    this.publicationDay = publicationDay;
  }

  public IdentifierDto publicationMonth(Integer publicationMonth) {
    this.publicationMonth = publicationMonth;
    return this;
  }

   /**
   * Get publicationMonth
   * @return publicationMonth
  **/
  @Schema(example = "12", description = "")
  public Integer getPublicationMonth() {
    return publicationMonth;
  }

  public void setPublicationMonth(Integer publicationMonth) {
    this.publicationMonth = publicationMonth;
  }

  public IdentifierDto publicationYear(Integer publicationYear) {
    this.publicationYear = publicationYear;
    return this;
  }

   /**
   * Get publicationYear
   * @return publicationYear
  **/
  @Schema(example = "2022", required = true, description = "")
  public Integer getPublicationYear() {
    return publicationYear;
  }

  public void setPublicationYear(Integer publicationYear) {
    this.publicationYear = publicationYear;
  }

  public IdentifierDto lastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
    return this;
  }

   /**
   * Get lastModified
   * @return lastModified
  **/
  @Schema(description = "")
  public OffsetDateTime getLastModified() {
    return lastModified;
  }

  public void setLastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    IdentifierDto identifierDto = (IdentifierDto) o;
    return Objects.equals(this.id, identifierDto.id) &&
        Objects.equals(this.type, identifierDto.type) &&
        Objects.equals(this.title, identifierDto.title) &&
        Objects.equals(this.description, identifierDto.description) &&
        Objects.equals(this.query, identifierDto.query) &&
        Objects.equals(this.execution, identifierDto.execution) &&
        Objects.equals(this.visibility, identifierDto.visibility) &&
        Objects.equals(this.doi, identifierDto.doi) &&
        Objects.equals(this.publisher, identifierDto.publisher) &&
        Objects.equals(this.language, identifierDto.language) &&
        Objects.equals(this.license, identifierDto.license) &&
        Objects.equals(this.creators, identifierDto.creators) &&
        Objects.equals(this.created, identifierDto.created) &&
        Objects.equals(this.containerId, identifierDto.containerId) &&
        Objects.equals(this.databaseId, identifierDto.databaseId) &&
        Objects.equals(this.queryId, identifierDto.queryId) &&
        Objects.equals(this.queryNormalized, identifierDto.queryNormalized) &&
        Objects.equals(this.related, identifierDto.related) &&
        Objects.equals(this.queryHash, identifierDto.queryHash) &&
        Objects.equals(this.resultHash, identifierDto.resultHash) &&
        Objects.equals(this.resultNumber, identifierDto.resultNumber) &&
        Objects.equals(this.publicationDay, identifierDto.publicationDay) &&
        Objects.equals(this.publicationMonth, identifierDto.publicationMonth) &&
        Objects.equals(this.publicationYear, identifierDto.publicationYear) &&
        Objects.equals(this.lastModified, identifierDto.lastModified);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, type, title, description, query, execution, visibility, doi, publisher, language, license, creators, created, containerId, databaseId, queryId, queryNormalized, related, queryHash, resultHash, resultNumber, publicationDay, publicationMonth, publicationYear, lastModified);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class IdentifierDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    query: ").append(toIndentedString(query)).append("\n");
    sb.append("    execution: ").append(toIndentedString(execution)).append("\n");
    sb.append("    visibility: ").append(toIndentedString(visibility)).append("\n");
    sb.append("    doi: ").append(toIndentedString(doi)).append("\n");
    sb.append("    publisher: ").append(toIndentedString(publisher)).append("\n");
    sb.append("    language: ").append(toIndentedString(language)).append("\n");
    sb.append("    license: ").append(toIndentedString(license)).append("\n");
    sb.append("    creators: ").append(toIndentedString(creators)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    containerId: ").append(toIndentedString(containerId)).append("\n");
    sb.append("    databaseId: ").append(toIndentedString(databaseId)).append("\n");
    sb.append("    queryId: ").append(toIndentedString(queryId)).append("\n");
    sb.append("    queryNormalized: ").append(toIndentedString(queryNormalized)).append("\n");
    sb.append("    related: ").append(toIndentedString(related)).append("\n");
    sb.append("    queryHash: ").append(toIndentedString(queryHash)).append("\n");
    sb.append("    resultHash: ").append(toIndentedString(resultHash)).append("\n");
    sb.append("    resultNumber: ").append(toIndentedString(resultNumber)).append("\n");
    sb.append("    publicationDay: ").append(toIndentedString(publicationDay)).append("\n");
    sb.append("    publicationMonth: ").append(toIndentedString(publicationMonth)).append("\n");
    sb.append("    publicationYear: ").append(toIndentedString(publicationYear)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
