/*
 * Database Repository Container Service API
 * Service that manages the containers
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.ImageEnvItemDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * ImageChangeDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T11:48:18.502846+01:00[Europe/Vienna]")
public class ImageChangeDto {
  @SerializedName("defaultPort")
  private Integer defaultPort = null;

  @SerializedName("environment")
  private List<ImageEnvItemDto> environment = null;

  @SerializedName("dialect")
  private String dialect = null;

  @SerializedName("driver_class")
  private String driverClass = null;

  @SerializedName("jdbc_method")
  private String jdbcMethod = null;

  public ImageChangeDto defaultPort(Integer defaultPort) {
    this.defaultPort = defaultPort;
    return this;
  }

   /**
   * Get defaultPort
   * minimum: 1024
   * maximum: 65535
   * @return defaultPort
  **/
  @Schema(example = "5432", description = "")
  public Integer getDefaultPort() {
    return defaultPort;
  }

  public void setDefaultPort(Integer defaultPort) {
    this.defaultPort = defaultPort;
  }

  public ImageChangeDto environment(List<ImageEnvItemDto> environment) {
    this.environment = environment;
    return this;
  }

  public ImageChangeDto addEnvironmentItem(ImageEnvItemDto environmentItem) {
    if (this.environment == null) {
      this.environment = new ArrayList<ImageEnvItemDto>();
    }
    this.environment.add(environmentItem);
    return this;
  }

   /**
   * Get environment
   * @return environment
  **/
  @Schema(description = "")
  public List<ImageEnvItemDto> getEnvironment() {
    return environment;
  }

  public void setEnvironment(List<ImageEnvItemDto> environment) {
    this.environment = environment;
  }

  public ImageChangeDto dialect(String dialect) {
    this.dialect = dialect;
    return this;
  }

   /**
   * Get dialect
   * @return dialect
  **/
  @Schema(example = "Postgres", required = true, description = "")
  public String getDialect() {
    return dialect;
  }

  public void setDialect(String dialect) {
    this.dialect = dialect;
  }

  public ImageChangeDto driverClass(String driverClass) {
    this.driverClass = driverClass;
    return this;
  }

   /**
   * Get driverClass
   * @return driverClass
  **/
  @Schema(example = "org.postgresql.Driver", required = true, description = "")
  public String getDriverClass() {
    return driverClass;
  }

  public void setDriverClass(String driverClass) {
    this.driverClass = driverClass;
  }

  public ImageChangeDto jdbcMethod(String jdbcMethod) {
    this.jdbcMethod = jdbcMethod;
    return this;
  }

   /**
   * Get jdbcMethod
   * @return jdbcMethod
  **/
  @Schema(example = "postgresql", required = true, description = "")
  public String getJdbcMethod() {
    return jdbcMethod;
  }

  public void setJdbcMethod(String jdbcMethod) {
    this.jdbcMethod = jdbcMethod;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ImageChangeDto imageChangeDto = (ImageChangeDto) o;
    return Objects.equals(this.defaultPort, imageChangeDto.defaultPort) &&
        Objects.equals(this.environment, imageChangeDto.environment) &&
        Objects.equals(this.dialect, imageChangeDto.dialect) &&
        Objects.equals(this.driverClass, imageChangeDto.driverClass) &&
        Objects.equals(this.jdbcMethod, imageChangeDto.jdbcMethod);
  }

  @Override
  public int hashCode() {
    return Objects.hash(defaultPort, environment, dialect, driverClass, jdbcMethod);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ImageChangeDto {\n");
    
    sb.append("    defaultPort: ").append(toIndentedString(defaultPort)).append("\n");
    sb.append("    environment: ").append(toIndentedString(environment)).append("\n");
    sb.append("    dialect: ").append(toIndentedString(dialect)).append("\n");
    sb.append("    driverClass: ").append(toIndentedString(driverClass)).append("\n");
    sb.append("    jdbcMethod: ").append(toIndentedString(jdbcMethod)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
