/*
 * Database Repository Container Service API
 * Service that manages the containers
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.ImageEnvItemDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * ImageCreateDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T11:48:18.502846+01:00[Europe/Vienna]")
public class ImageCreateDto {
  @SerializedName("repository")
  private String repository = null;

  @SerializedName("tag")
  private String tag = null;

  @SerializedName("dialect")
  private String dialect = null;

  @SerializedName("environment")
  private List<ImageEnvItemDto> environment = null;

  @SerializedName("driver_class")
  private String driverClass = null;

  @SerializedName("jdbc_method")
  private String jdbcMethod = null;

  @SerializedName("default_port")
  private Integer defaultPort = null;

  public ImageCreateDto repository(String repository) {
    this.repository = repository;
    return this;
  }

   /**
   * Get repository
   * @return repository
  **/
  @Schema(example = "mariadb", required = true, description = "")
  public String getRepository() {
    return repository;
  }

  public void setRepository(String repository) {
    this.repository = repository;
  }

  public ImageCreateDto tag(String tag) {
    this.tag = tag;
    return this;
  }

   /**
   * Get tag
   * @return tag
  **/
  @Schema(required = true, description = "")
  public String getTag() {
    return tag;
  }

  public void setTag(String tag) {
    this.tag = tag;
  }

  public ImageCreateDto dialect(String dialect) {
    this.dialect = dialect;
    return this;
  }

   /**
   * Get dialect
   * @return dialect
  **/
  @Schema(required = true, description = "")
  public String getDialect() {
    return dialect;
  }

  public void setDialect(String dialect) {
    this.dialect = dialect;
  }

  public ImageCreateDto environment(List<ImageEnvItemDto> environment) {
    this.environment = environment;
    return this;
  }

  public ImageCreateDto addEnvironmentItem(ImageEnvItemDto environmentItem) {
    if (this.environment == null) {
      this.environment = new ArrayList<ImageEnvItemDto>();
    }
    this.environment.add(environmentItem);
    return this;
  }

   /**
   * Get environment
   * @return environment
  **/
  @Schema(description = "")
  public List<ImageEnvItemDto> getEnvironment() {
    return environment;
  }

  public void setEnvironment(List<ImageEnvItemDto> environment) {
    this.environment = environment;
  }

  public ImageCreateDto driverClass(String driverClass) {
    this.driverClass = driverClass;
    return this;
  }

   /**
   * Get driverClass
   * @return driverClass
  **/
  @Schema(required = true, description = "")
  public String getDriverClass() {
    return driverClass;
  }

  public void setDriverClass(String driverClass) {
    this.driverClass = driverClass;
  }

  public ImageCreateDto jdbcMethod(String jdbcMethod) {
    this.jdbcMethod = jdbcMethod;
    return this;
  }

   /**
   * Get jdbcMethod
   * @return jdbcMethod
  **/
  @Schema(required = true, description = "")
  public String getJdbcMethod() {
    return jdbcMethod;
  }

  public void setJdbcMethod(String jdbcMethod) {
    this.jdbcMethod = jdbcMethod;
  }

  public ImageCreateDto defaultPort(Integer defaultPort) {
    this.defaultPort = defaultPort;
    return this;
  }

   /**
   * Get defaultPort
   * @return defaultPort
  **/
  @Schema(required = true, description = "")
  public Integer getDefaultPort() {
    return defaultPort;
  }

  public void setDefaultPort(Integer defaultPort) {
    this.defaultPort = defaultPort;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ImageCreateDto imageCreateDto = (ImageCreateDto) o;
    return Objects.equals(this.repository, imageCreateDto.repository) &&
        Objects.equals(this.tag, imageCreateDto.tag) &&
        Objects.equals(this.dialect, imageCreateDto.dialect) &&
        Objects.equals(this.environment, imageCreateDto.environment) &&
        Objects.equals(this.driverClass, imageCreateDto.driverClass) &&
        Objects.equals(this.jdbcMethod, imageCreateDto.jdbcMethod) &&
        Objects.equals(this.defaultPort, imageCreateDto.defaultPort);
  }

  @Override
  public int hashCode() {
    return Objects.hash(repository, tag, dialect, environment, driverClass, jdbcMethod, defaultPort);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ImageCreateDto {\n");
    
    sb.append("    repository: ").append(toIndentedString(repository)).append("\n");
    sb.append("    tag: ").append(toIndentedString(tag)).append("\n");
    sb.append("    dialect: ").append(toIndentedString(dialect)).append("\n");
    sb.append("    environment: ").append(toIndentedString(environment)).append("\n");
    sb.append("    driverClass: ").append(toIndentedString(driverClass)).append("\n");
    sb.append("    jdbcMethod: ").append(toIndentedString(jdbcMethod)).append("\n");
    sb.append("    defaultPort: ").append(toIndentedString(defaultPort)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
