/*
 * Database Repository Container Service API
 * Service that manages the containers
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.ImageDateDto;
import io.swagger.client.model.ImageEnvItemDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.threeten.bp.OffsetDateTime;
/**
 * ImageDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T11:48:18.502846+01:00[Europe/Vienna]")
public class ImageDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("repository")
  private String repository = null;

  @SerializedName("tag")
  private String tag = null;

  @SerializedName("dialect")
  private String dialect = null;

  @SerializedName("hash")
  private String hash = null;

  @SerializedName("compiled")
  private OffsetDateTime compiled = null;

  @SerializedName("size")
  private Integer size = null;

  @SerializedName("environment")
  private List<ImageEnvItemDto> environment = new ArrayList<ImageEnvItemDto>();

  @SerializedName("driver_class")
  private String driverClass = null;

  @SerializedName("date_formats")
  private List<ImageDateDto> dateFormats = null;

  @SerializedName("jdbc_method")
  private String jdbcMethod = null;

  @SerializedName("default_port")
  private Integer defaultPort = null;

  public ImageDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public ImageDto repository(String repository) {
    this.repository = repository;
    return this;
  }

   /**
   * Get repository
   * @return repository
  **/
  @Schema(example = "mariadb", required = true, description = "")
  public String getRepository() {
    return repository;
  }

  public void setRepository(String repository) {
    this.repository = repository;
  }

  public ImageDto tag(String tag) {
    this.tag = tag;
    return this;
  }

   /**
   * Get tag
   * @return tag
  **/
  @Schema(example = "10.5", required = true, description = "")
  public String getTag() {
    return tag;
  }

  public void setTag(String tag) {
    this.tag = tag;
  }

  public ImageDto dialect(String dialect) {
    this.dialect = dialect;
    return this;
  }

   /**
   * Get dialect
   * @return dialect
  **/
  @Schema(example = "org.hibernate.dialect.MariaDBDialect", required = true, description = "")
  public String getDialect() {
    return dialect;
  }

  public void setDialect(String dialect) {
    this.dialect = dialect;
  }

  public ImageDto hash(String hash) {
    this.hash = hash;
    return this;
  }

   /**
   * Get hash
   * @return hash
  **/
  @Schema(example = "sha256:c5ec7353d87dfc35067e7bffeb25d6a0d52dad41e8b7357213e3b12d6e7ff78e", description = "")
  public String getHash() {
    return hash;
  }

  public void setHash(String hash) {
    this.hash = hash;
  }

  public ImageDto compiled(OffsetDateTime compiled) {
    this.compiled = compiled;
    return this;
  }

   /**
   * Get compiled
   * @return compiled
  **/
  @Schema(example = "2021-03-12T15:26:21.678396092Z", description = "")
  public OffsetDateTime getCompiled() {
    return compiled;
  }

  public void setCompiled(OffsetDateTime compiled) {
    this.compiled = compiled;
  }

  public ImageDto size(Integer size) {
    this.size = size;
    return this;
  }

   /**
   * Get size
   * @return size
  **/
  @Schema(example = "314295447", description = "")
  public Integer getSize() {
    return size;
  }

  public void setSize(Integer size) {
    this.size = size;
  }

  public ImageDto environment(List<ImageEnvItemDto> environment) {
    this.environment = environment;
    return this;
  }

  public ImageDto addEnvironmentItem(ImageEnvItemDto environmentItem) {
    this.environment.add(environmentItem);
    return this;
  }

   /**
   * Get environment
   * @return environment
  **/
  @Schema(required = true, description = "")
  public List<ImageEnvItemDto> getEnvironment() {
    return environment;
  }

  public void setEnvironment(List<ImageEnvItemDto> environment) {
    this.environment = environment;
  }

  public ImageDto driverClass(String driverClass) {
    this.driverClass = driverClass;
    return this;
  }

   /**
   * Get driverClass
   * @return driverClass
  **/
  @Schema(example = "org.mariadb.jdbc.Driver", required = true, description = "")
  public String getDriverClass() {
    return driverClass;
  }

  public void setDriverClass(String driverClass) {
    this.driverClass = driverClass;
  }

  public ImageDto dateFormats(List<ImageDateDto> dateFormats) {
    this.dateFormats = dateFormats;
    return this;
  }

  public ImageDto addDateFormatsItem(ImageDateDto dateFormatsItem) {
    if (this.dateFormats == null) {
      this.dateFormats = new ArrayList<ImageDateDto>();
    }
    this.dateFormats.add(dateFormatsItem);
    return this;
  }

   /**
   * Get dateFormats
   * @return dateFormats
  **/
  @Schema(description = "")
  public List<ImageDateDto> getDateFormats() {
    return dateFormats;
  }

  public void setDateFormats(List<ImageDateDto> dateFormats) {
    this.dateFormats = dateFormats;
  }

  public ImageDto jdbcMethod(String jdbcMethod) {
    this.jdbcMethod = jdbcMethod;
    return this;
  }

   /**
   * Get jdbcMethod
   * @return jdbcMethod
  **/
  @Schema(example = "mariadb", required = true, description = "")
  public String getJdbcMethod() {
    return jdbcMethod;
  }

  public void setJdbcMethod(String jdbcMethod) {
    this.jdbcMethod = jdbcMethod;
  }

  public ImageDto defaultPort(Integer defaultPort) {
    this.defaultPort = defaultPort;
    return this;
  }

   /**
   * Get defaultPort
   * @return defaultPort
  **/
  @Schema(example = "3306", required = true, description = "")
  public Integer getDefaultPort() {
    return defaultPort;
  }

  public void setDefaultPort(Integer defaultPort) {
    this.defaultPort = defaultPort;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ImageDto imageDto = (ImageDto) o;
    return Objects.equals(this.id, imageDto.id) &&
        Objects.equals(this.repository, imageDto.repository) &&
        Objects.equals(this.tag, imageDto.tag) &&
        Objects.equals(this.dialect, imageDto.dialect) &&
        Objects.equals(this.hash, imageDto.hash) &&
        Objects.equals(this.compiled, imageDto.compiled) &&
        Objects.equals(this.size, imageDto.size) &&
        Objects.equals(this.environment, imageDto.environment) &&
        Objects.equals(this.driverClass, imageDto.driverClass) &&
        Objects.equals(this.dateFormats, imageDto.dateFormats) &&
        Objects.equals(this.jdbcMethod, imageDto.jdbcMethod) &&
        Objects.equals(this.defaultPort, imageDto.defaultPort);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, repository, tag, dialect, hash, compiled, size, environment, driverClass, dateFormats, jdbcMethod, defaultPort);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ImageDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    repository: ").append(toIndentedString(repository)).append("\n");
    sb.append("    tag: ").append(toIndentedString(tag)).append("\n");
    sb.append("    dialect: ").append(toIndentedString(dialect)).append("\n");
    sb.append("    hash: ").append(toIndentedString(hash)).append("\n");
    sb.append("    compiled: ").append(toIndentedString(compiled)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    environment: ").append(toIndentedString(environment)).append("\n");
    sb.append("    driverClass: ").append(toIndentedString(driverClass)).append("\n");
    sb.append("    dateFormats: ").append(toIndentedString(dateFormats)).append("\n");
    sb.append("    jdbcMethod: ").append(toIndentedString(jdbcMethod)).append("\n");
    sb.append("    defaultPort: ").append(toIndentedString(defaultPort)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
