/*
 * Database Repository Query Service API
 * Service that manages the queries
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.UserDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import org.threeten.bp.OffsetDateTime;
/**
 * QueryBriefDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T12:27:08.557443+01:00[Europe/Vienna]")
public class QueryBriefDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("cid")
  private Long cid = null;

  @SerializedName("dbid")
  private Long dbid = null;

  @SerializedName("creator")
  private UserDto creator = null;

  @SerializedName("execution")
  private OffsetDateTime execution = null;

  @SerializedName("query")
  private String query = null;

  /**
   * Gets or Sets type
   */
  @JsonAdapter(TypeEnum.Adapter.class)
  public enum TypeEnum {
    QUERY("query"),
    VIEW("view");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static TypeEnum fromValue(String input) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<TypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public TypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return TypeEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("type")
  private TypeEnum type = null;

  @SerializedName("created")
  private OffsetDateTime created = null;

  @SerializedName("query_normalized")
  private String queryNormalized = null;

  @SerializedName("query_hash")
  private String queryHash = null;

  @SerializedName("result_hash")
  private String resultHash = null;

  @SerializedName("result_number")
  private Long resultNumber = null;

  @SerializedName("last_modified")
  private OffsetDateTime lastModified = null;

  public QueryBriefDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public QueryBriefDto cid(Long cid) {
    this.cid = cid;
    return this;
  }

   /**
   * Get cid
   * @return cid
  **/
  @Schema(required = true, description = "")
  public Long getCid() {
    return cid;
  }

  public void setCid(Long cid) {
    this.cid = cid;
  }

  public QueryBriefDto dbid(Long dbid) {
    this.dbid = dbid;
    return this;
  }

   /**
   * Get dbid
   * @return dbid
  **/
  @Schema(required = true, description = "")
  public Long getDbid() {
    return dbid;
  }

  public void setDbid(Long dbid) {
    this.dbid = dbid;
  }

  public QueryBriefDto creator(UserDto creator) {
    this.creator = creator;
    return this;
  }

   /**
   * Get creator
   * @return creator
  **/
  @Schema(required = true, description = "")
  public UserDto getCreator() {
    return creator;
  }

  public void setCreator(UserDto creator) {
    this.creator = creator;
  }

  public QueryBriefDto execution(OffsetDateTime execution) {
    this.execution = execution;
    return this;
  }

   /**
   * Get execution
   * @return execution
  **/
  @Schema(description = "")
  public OffsetDateTime getExecution() {
    return execution;
  }

  public void setExecution(OffsetDateTime execution) {
    this.execution = execution;
  }

  public QueryBriefDto query(String query) {
    this.query = query;
    return this;
  }

   /**
   * Get query
   * @return query
  **/
  @Schema(example = "SELECT `id` FROM `air_quality`", required = true, description = "")
  public String getQuery() {
    return query;
  }

  public void setQuery(String query) {
    this.query = query;
  }

  public QueryBriefDto type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @Schema(example = "query", description = "")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public QueryBriefDto created(OffsetDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @Schema(required = true, description = "")
  public OffsetDateTime getCreated() {
    return created;
  }

  public void setCreated(OffsetDateTime created) {
    this.created = created;
  }

  public QueryBriefDto queryNormalized(String queryNormalized) {
    this.queryNormalized = queryNormalized;
    return this;
  }

   /**
   * Get queryNormalized
   * @return queryNormalized
  **/
  @Schema(example = "SELECT `id` FROM `air_quality`", description = "")
  public String getQueryNormalized() {
    return queryNormalized;
  }

  public void setQueryNormalized(String queryNormalized) {
    this.queryNormalized = queryNormalized;
  }

  public QueryBriefDto queryHash(String queryHash) {
    this.queryHash = queryHash;
    return this;
  }

   /**
   * Get queryHash
   * @return queryHash
  **/
  @Schema(example = "17e682f060b5f8e47ea04c5c4855908b0a5ad612022260fe50e11ecb0cc0ab76", required = true, description = "")
  public String getQueryHash() {
    return queryHash;
  }

  public void setQueryHash(String queryHash) {
    this.queryHash = queryHash;
  }

  public QueryBriefDto resultHash(String resultHash) {
    this.resultHash = resultHash;
    return this;
  }

   /**
   * Get resultHash
   * @return resultHash
  **/
  @Schema(example = "17e682f060b5f8e47ea04c5c4855908b0a5ad612022260fe50e11ecb0cc0ab76", description = "")
  public String getResultHash() {
    return resultHash;
  }

  public void setResultHash(String resultHash) {
    this.resultHash = resultHash;
  }

  public QueryBriefDto resultNumber(Long resultNumber) {
    this.resultNumber = resultNumber;
    return this;
  }

   /**
   * Get resultNumber
   * @return resultNumber
  **/
  @Schema(example = "1", description = "")
  public Long getResultNumber() {
    return resultNumber;
  }

  public void setResultNumber(Long resultNumber) {
    this.resultNumber = resultNumber;
  }

  public QueryBriefDto lastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
    return this;
  }

   /**
   * Get lastModified
   * @return lastModified
  **/
  @Schema(description = "")
  public OffsetDateTime getLastModified() {
    return lastModified;
  }

  public void setLastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    QueryBriefDto queryBriefDto = (QueryBriefDto) o;
    return Objects.equals(this.id, queryBriefDto.id) &&
        Objects.equals(this.cid, queryBriefDto.cid) &&
        Objects.equals(this.dbid, queryBriefDto.dbid) &&
        Objects.equals(this.creator, queryBriefDto.creator) &&
        Objects.equals(this.execution, queryBriefDto.execution) &&
        Objects.equals(this.query, queryBriefDto.query) &&
        Objects.equals(this.type, queryBriefDto.type) &&
        Objects.equals(this.created, queryBriefDto.created) &&
        Objects.equals(this.queryNormalized, queryBriefDto.queryNormalized) &&
        Objects.equals(this.queryHash, queryBriefDto.queryHash) &&
        Objects.equals(this.resultHash, queryBriefDto.resultHash) &&
        Objects.equals(this.resultNumber, queryBriefDto.resultNumber) &&
        Objects.equals(this.lastModified, queryBriefDto.lastModified);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, cid, dbid, creator, execution, query, type, created, queryNormalized, queryHash, resultHash, resultNumber, lastModified);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class QueryBriefDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    cid: ").append(toIndentedString(cid)).append("\n");
    sb.append("    dbid: ").append(toIndentedString(dbid)).append("\n");
    sb.append("    creator: ").append(toIndentedString(creator)).append("\n");
    sb.append("    execution: ").append(toIndentedString(execution)).append("\n");
    sb.append("    query: ").append(toIndentedString(query)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    queryNormalized: ").append(toIndentedString(queryNormalized)).append("\n");
    sb.append("    queryHash: ").append(toIndentedString(queryHash)).append("\n");
    sb.append("    resultHash: ").append(toIndentedString(resultHash)).append("\n");
    sb.append("    resultNumber: ").append(toIndentedString(resultNumber)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
