/*
 * Database Repository Container Service API
 * Service that manages the containers
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import org.threeten.bp.OffsetDateTime;
/**
 * RelatedIdentifierDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T11:48:18.502846+01:00[Europe/Vienna]")
public class RelatedIdentifierDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("value")
  private String value = null;

  /**
   * Gets or Sets type
   */
  @JsonAdapter(TypeEnum.Adapter.class)
  public enum TypeEnum {
    DOI("DOI"),
    URL("URL"),
    URN("URN"),
    ARK("ARK"),
    ARXIV("arXiv"),
    BIBCODE("bibcode"),
    EAN13("EAN13"),
    EISSN("EISSN"),
    HANDLE("Handle"),
    IGSN("IGSN"),
    ISBN("ISBN"),
    ISTC("ISTC"),
    LISSN("LISSN"),
    LSID("LSID"),
    PMID("PMID"),
    PURL("PURL"),
    UPC("UPC"),
    W3ID("w3id");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static TypeEnum fromValue(String input) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<TypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public TypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return TypeEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("type")
  private TypeEnum type = null;

  /**
   * Gets or Sets relation
   */
  @JsonAdapter(RelationEnum.Adapter.class)
  public enum RelationEnum {
    ISCITEDBY("IsCitedBy"),
    CITES("Cites"),
    ISSUPPLEMENTTO("IsSupplementTo"),
    ISSUPPLEMENTEDBY("IsSupplementedBy"),
    ISCONTINUEDBY("IsContinuedBy"),
    CONTINUES("Continues"),
    ISDESCRIBEDBY("IsDescribedBy"),
    DESCRIBES("Describes"),
    HASMETADATA("HasMetadata"),
    ISMETADATAFOR("IsMetadataFor"),
    HASVERSION("HasVersion"),
    ISVERSIONOF("IsVersionOf"),
    ISNEWVERSIONOF("IsNewVersionOf"),
    ISPREVIOUSVERSIONOF("IsPreviousVersionOf"),
    ISPARTOF("IsPartOf"),
    HASPART("HasPart"),
    ISPUBLISHEDIN("IsPublishedIn"),
    ISREFERENCEDBY("IsReferencedBy"),
    REFERENCES("References"),
    ISDOCUMENTEDBY("IsDocumentedBy"),
    DOCUMENTS("Documents"),
    ISCOMPILEDBY("IsCompiledBy"),
    COMPILES("Compiles"),
    ISVARIANTFORMOF("IsVariantFormOf"),
    ISORIGINALFORMOF("IsOriginalFormOf"),
    ISIDENTICALTO("IsIdenticalTo"),
    ISREVIEWEDBY("IsReviewedBy"),
    REVIEWS("Reviews"),
    ISDERIVEDFROM("IsDerivedFrom"),
    ISSOURCEOF("IsSourceOf"),
    ISREQUIREDBY("IsRequiredBy"),
    REQUIRES("Requires"),
    ISOBSOLETEDBY("IsObsoletedBy"),
    OBSOLETES("Obsoletes");

    private String value;

    RelationEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static RelationEnum fromValue(String input) {
      for (RelationEnum b : RelationEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<RelationEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final RelationEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public RelationEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return RelationEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("relation")
  private RelationEnum relation = null;

  @SerializedName("created")
  private OffsetDateTime created = null;

  @SerializedName("last_modified")
  private OffsetDateTime lastModified = null;

  public RelatedIdentifierDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public RelatedIdentifierDto value(String value) {
    this.value = value;
    return this;
  }

   /**
   * Get value
   * @return value
  **/
  @Schema(example = "10.70124/dc4zh-9ce78", required = true, description = "")
  public String getValue() {
    return value;
  }

  public void setValue(String value) {
    this.value = value;
  }

  public RelatedIdentifierDto type(TypeEnum type) {
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @Schema(example = "DOI", description = "")
  public TypeEnum getType() {
    return type;
  }

  public void setType(TypeEnum type) {
    this.type = type;
  }

  public RelatedIdentifierDto relation(RelationEnum relation) {
    this.relation = relation;
    return this;
  }

   /**
   * Get relation
   * @return relation
  **/
  @Schema(example = "Cites", description = "")
  public RelationEnum getRelation() {
    return relation;
  }

  public void setRelation(RelationEnum relation) {
    this.relation = relation;
  }

  public RelatedIdentifierDto created(OffsetDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @Schema(required = true, description = "")
  public OffsetDateTime getCreated() {
    return created;
  }

  public void setCreated(OffsetDateTime created) {
    this.created = created;
  }

  public RelatedIdentifierDto lastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
    return this;
  }

   /**
   * Get lastModified
   * @return lastModified
  **/
  @Schema(description = "")
  public OffsetDateTime getLastModified() {
    return lastModified;
  }

  public void setLastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RelatedIdentifierDto relatedIdentifierDto = (RelatedIdentifierDto) o;
    return Objects.equals(this.id, relatedIdentifierDto.id) &&
        Objects.equals(this.value, relatedIdentifierDto.value) &&
        Objects.equals(this.type, relatedIdentifierDto.type) &&
        Objects.equals(this.relation, relatedIdentifierDto.relation) &&
        Objects.equals(this.created, relatedIdentifierDto.created) &&
        Objects.equals(this.lastModified, relatedIdentifierDto.lastModified);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, value, type, relation, created, lastModified);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RelatedIdentifierDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    value: ").append(toIndentedString(value)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    relation: ").append(toIndentedString(relation)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
