/*
 * Database Repository Table Service API
 * Service that manages the tables
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.ColumnDto;
import io.swagger.client.model.UserBriefDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.threeten.bp.OffsetDateTime;
/**
 * TableDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T12:29:06.419178+01:00[Europe/Vienna]")
public class TableDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("creator")
  private UserBriefDto creator = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("created")
  private OffsetDateTime created = null;

  @SerializedName("columns")
  private List<ColumnDto> columns = new ArrayList<ColumnDto>();

  @SerializedName("internal_name")
  private String internalName = null;

  @SerializedName("queue_name")
  private String queueName = null;

  @SerializedName("routing_key")
  private String routingKey = null;

  public TableDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public TableDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @Schema(example = "Air Quality", required = true, description = "")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public TableDto creator(UserBriefDto creator) {
    this.creator = creator;
    return this;
  }

   /**
   * Get creator
   * @return creator
  **/
  @Schema(required = true, description = "")
  public UserBriefDto getCreator() {
    return creator;
  }

  public void setCreator(UserBriefDto creator) {
    this.creator = creator;
  }

  public TableDto description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Get description
   * @return description
  **/
  @Schema(example = "Air Quality in Austria", required = true, description = "")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public TableDto created(OffsetDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @Schema(description = "")
  public OffsetDateTime getCreated() {
    return created;
  }

  public void setCreated(OffsetDateTime created) {
    this.created = created;
  }

  public TableDto columns(List<ColumnDto> columns) {
    this.columns = columns;
    return this;
  }

  public TableDto addColumnsItem(ColumnDto columnsItem) {
    this.columns.add(columnsItem);
    return this;
  }

   /**
   * Get columns
   * @return columns
  **/
  @Schema(required = true, description = "")
  public List<ColumnDto> getColumns() {
    return columns;
  }

  public void setColumns(List<ColumnDto> columns) {
    this.columns = columns;
  }

  public TableDto internalName(String internalName) {
    this.internalName = internalName;
    return this;
  }

   /**
   * Get internalName
   * @return internalName
  **/
  @Schema(example = "air_quality", required = true, description = "")
  public String getInternalName() {
    return internalName;
  }

  public void setInternalName(String internalName) {
    this.internalName = internalName;
  }

  public TableDto queueName(String queueName) {
    this.queueName = queueName;
    return this;
  }

   /**
   * Get queueName
   * @return queueName
  **/
  @Schema(example = "dbrepo/4/4/2", required = true, description = "")
  public String getQueueName() {
    return queueName;
  }

  public void setQueueName(String queueName) {
    this.queueName = queueName;
  }

  public TableDto routingKey(String routingKey) {
    this.routingKey = routingKey;
    return this;
  }

   /**
   * Get routingKey
   * @return routingKey
  **/
  @Schema(example = "dbrepo/4/4/2/1", required = true, description = "")
  public String getRoutingKey() {
    return routingKey;
  }

  public void setRoutingKey(String routingKey) {
    this.routingKey = routingKey;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TableDto tableDto = (TableDto) o;
    return Objects.equals(this.id, tableDto.id) &&
        Objects.equals(this.name, tableDto.name) &&
        Objects.equals(this.creator, tableDto.creator) &&
        Objects.equals(this.description, tableDto.description) &&
        Objects.equals(this.created, tableDto.created) &&
        Objects.equals(this.columns, tableDto.columns) &&
        Objects.equals(this.internalName, tableDto.internalName) &&
        Objects.equals(this.queueName, tableDto.queueName) &&
        Objects.equals(this.routingKey, tableDto.routingKey);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, creator, description, created, columns, internalName, queueName, routingKey);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TableDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    creator: ").append(toIndentedString(creator)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    columns: ").append(toIndentedString(columns)).append("\n");
    sb.append("    internalName: ").append(toIndentedString(internalName)).append("\n");
    sb.append("    queueName: ").append(toIndentedString(queueName)).append("\n");
    sb.append("    routingKey: ").append(toIndentedString(routingKey)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
