/*
 * Database Repository Container Service API
 * Service that manages the containers
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * UserBriefDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T11:48:18.502846+01:00[Europe/Vienna]")
public class UserBriefDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("username")
  private String username = null;

  @SerializedName("titlesBefore")
  private String titlesBefore = null;

  @SerializedName("titlesAfter")
  private String titlesAfter = null;

  @SerializedName("firstname")
  private String firstname = null;

  @SerializedName("lastname")
  private String lastname = null;

  @SerializedName("affiliation")
  private String affiliation = null;

  @SerializedName("orcid")
  private String orcid = null;

  @SerializedName("roles")
  private List<String> roles = new ArrayList<String>();

  @SerializedName("themeDark")
  private Boolean themeDark = null;

  @SerializedName("emailVerified")
  private Boolean emailVerified = null;

  public UserBriefDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public UserBriefDto username(String username) {
    this.username = username;
    return this;
  }

   /**
   * Only contains lowercase characters
   * @return username
  **/
  @Schema(example = "user", required = true, description = "Only contains lowercase characters")
  public String getUsername() {
    return username;
  }

  public void setUsername(String username) {
    this.username = username;
  }

  public UserBriefDto titlesBefore(String titlesBefore) {
    this.titlesBefore = titlesBefore;
    return this;
  }

   /**
   * Get titlesBefore
   * @return titlesBefore
  **/
  @Schema(description = "")
  public String getTitlesBefore() {
    return titlesBefore;
  }

  public void setTitlesBefore(String titlesBefore) {
    this.titlesBefore = titlesBefore;
  }

  public UserBriefDto titlesAfter(String titlesAfter) {
    this.titlesAfter = titlesAfter;
    return this;
  }

   /**
   * Get titlesAfter
   * @return titlesAfter
  **/
  @Schema(description = "")
  public String getTitlesAfter() {
    return titlesAfter;
  }

  public void setTitlesAfter(String titlesAfter) {
    this.titlesAfter = titlesAfter;
  }

  public UserBriefDto firstname(String firstname) {
    this.firstname = firstname;
    return this;
  }

   /**
   * Get firstname
   * @return firstname
  **/
  @Schema(example = "Josiah", description = "")
  public String getFirstname() {
    return firstname;
  }

  public void setFirstname(String firstname) {
    this.firstname = firstname;
  }

  public UserBriefDto lastname(String lastname) {
    this.lastname = lastname;
    return this;
  }

   /**
   * Get lastname
   * @return lastname
  **/
  @Schema(example = "Carberry", description = "")
  public String getLastname() {
    return lastname;
  }

  public void setLastname(String lastname) {
    this.lastname = lastname;
  }

  public UserBriefDto affiliation(String affiliation) {
    this.affiliation = affiliation;
    return this;
  }

   /**
   * Get affiliation
   * @return affiliation
  **/
  @Schema(example = "Brown University", description = "")
  public String getAffiliation() {
    return affiliation;
  }

  public void setAffiliation(String affiliation) {
    this.affiliation = affiliation;
  }

  public UserBriefDto orcid(String orcid) {
    this.orcid = orcid;
    return this;
  }

   /**
   * Get orcid
   * @return orcid
  **/
  @Schema(example = "0000-0002-1825-0097", description = "")
  public String getOrcid() {
    return orcid;
  }

  public void setOrcid(String orcid) {
    this.orcid = orcid;
  }

  public UserBriefDto roles(List<String> roles) {
    this.roles = roles;
    return this;
  }

  public UserBriefDto addRolesItem(String rolesItem) {
    this.roles.add(rolesItem);
    return this;
  }

   /**
   * Roles of the user
   * @return roles
  **/
  @Schema(example = "[ROLE_RESEARCHER]", required = true, description = "Roles of the user")
  public List<String> getRoles() {
    return roles;
  }

  public void setRoles(List<String> roles) {
    this.roles = roles;
  }

  public UserBriefDto themeDark(Boolean themeDark) {
    this.themeDark = themeDark;
    return this;
  }

   /**
   * Get themeDark
   * @return themeDark
  **/
  @Schema(description = "")
  public Boolean isThemeDark() {
    return themeDark;
  }

  public void setThemeDark(Boolean themeDark) {
    this.themeDark = themeDark;
  }

  public UserBriefDto emailVerified(Boolean emailVerified) {
    this.emailVerified = emailVerified;
    return this;
  }

   /**
   * Get emailVerified
   * @return emailVerified
  **/
  @Schema(description = "")
  public Boolean isEmailVerified() {
    return emailVerified;
  }

  public void setEmailVerified(Boolean emailVerified) {
    this.emailVerified = emailVerified;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserBriefDto userBriefDto = (UserBriefDto) o;
    return Objects.equals(this.id, userBriefDto.id) &&
        Objects.equals(this.username, userBriefDto.username) &&
        Objects.equals(this.titlesBefore, userBriefDto.titlesBefore) &&
        Objects.equals(this.titlesAfter, userBriefDto.titlesAfter) &&
        Objects.equals(this.firstname, userBriefDto.firstname) &&
        Objects.equals(this.lastname, userBriefDto.lastname) &&
        Objects.equals(this.affiliation, userBriefDto.affiliation) &&
        Objects.equals(this.orcid, userBriefDto.orcid) &&
        Objects.equals(this.roles, userBriefDto.roles) &&
        Objects.equals(this.themeDark, userBriefDto.themeDark) &&
        Objects.equals(this.emailVerified, userBriefDto.emailVerified);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, username, titlesBefore, titlesAfter, firstname, lastname, affiliation, orcid, roles, themeDark, emailVerified);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserBriefDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    username: ").append(toIndentedString(username)).append("\n");
    sb.append("    titlesBefore: ").append(toIndentedString(titlesBefore)).append("\n");
    sb.append("    titlesAfter: ").append(toIndentedString(titlesAfter)).append("\n");
    sb.append("    firstname: ").append(toIndentedString(firstname)).append("\n");
    sb.append("    lastname: ").append(toIndentedString(lastname)).append("\n");
    sb.append("    affiliation: ").append(toIndentedString(affiliation)).append("\n");
    sb.append("    orcid: ").append(toIndentedString(orcid)).append("\n");
    sb.append("    roles: ").append(toIndentedString(roles)).append("\n");
    sb.append("    themeDark: ").append(toIndentedString(themeDark)).append("\n");
    sb.append("    emailVerified: ").append(toIndentedString(emailVerified)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
