/*
 * Database Repository Container Service API
 * Service that manages the containers
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.ContainerDto;
import io.swagger.client.model.GrantedAuthorityDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * UserDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T11:48:18.502846+01:00[Europe/Vienna]")
public class UserDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("authorities")
  private List<GrantedAuthorityDto> authorities = null;

  @SerializedName("username")
  private String username = null;

  @SerializedName("firstname")
  private String firstname = null;

  @SerializedName("lastname")
  private String lastname = null;

  @SerializedName("affiliation")
  private String affiliation = null;

  @SerializedName("orcid")
  private String orcid = null;

  @SerializedName("roles")
  private List<String> roles = new ArrayList<String>();

  @SerializedName("containers")
  private List<ContainerDto> containers = null;

  @SerializedName("databases")
  private List<ContainerDto> databases = null;

  @SerializedName("identifiers")
  private List<ContainerDto> identifiers = null;

  @SerializedName("email")
  private String email = null;

  @SerializedName("titles_before")
  private String titlesBefore = null;

  @SerializedName("titles_after")
  private String titlesAfter = null;

  @SerializedName("theme_dark")
  private Boolean themeDark = null;

  @SerializedName("email_verified")
  private Boolean emailVerified = null;

  public UserDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public UserDto authorities(List<GrantedAuthorityDto> authorities) {
    this.authorities = authorities;
    return this;
  }

  public UserDto addAuthoritiesItem(GrantedAuthorityDto authoritiesItem) {
    if (this.authorities == null) {
      this.authorities = new ArrayList<GrantedAuthorityDto>();
    }
    this.authorities.add(authoritiesItem);
    return this;
  }

   /**
   * Get authorities
   * @return authorities
  **/
  @Schema(description = "")
  public List<GrantedAuthorityDto> getAuthorities() {
    return authorities;
  }

  public void setAuthorities(List<GrantedAuthorityDto> authorities) {
    this.authorities = authorities;
  }

  public UserDto username(String username) {
    this.username = username;
    return this;
  }

   /**
   * Only contains lowercase characters
   * @return username
  **/
  @Schema(example = "jcarberry", required = true, description = "Only contains lowercase characters")
  public String getUsername() {
    return username;
  }

  public void setUsername(String username) {
    this.username = username;
  }

  public UserDto firstname(String firstname) {
    this.firstname = firstname;
    return this;
  }

   /**
   * Get firstname
   * @return firstname
  **/
  @Schema(example = "Josiah", description = "")
  public String getFirstname() {
    return firstname;
  }

  public void setFirstname(String firstname) {
    this.firstname = firstname;
  }

  public UserDto lastname(String lastname) {
    this.lastname = lastname;
    return this;
  }

   /**
   * Get lastname
   * @return lastname
  **/
  @Schema(example = "Carberry", description = "")
  public String getLastname() {
    return lastname;
  }

  public void setLastname(String lastname) {
    this.lastname = lastname;
  }

  public UserDto affiliation(String affiliation) {
    this.affiliation = affiliation;
    return this;
  }

   /**
   * Get affiliation
   * @return affiliation
  **/
  @Schema(example = "Brown University", description = "")
  public String getAffiliation() {
    return affiliation;
  }

  public void setAffiliation(String affiliation) {
    this.affiliation = affiliation;
  }

  public UserDto orcid(String orcid) {
    this.orcid = orcid;
    return this;
  }

   /**
   * Get orcid
   * @return orcid
  **/
  @Schema(example = "0000-0002-1825-0097", description = "")
  public String getOrcid() {
    return orcid;
  }

  public void setOrcid(String orcid) {
    this.orcid = orcid;
  }

  public UserDto roles(List<String> roles) {
    this.roles = roles;
    return this;
  }

  public UserDto addRolesItem(String rolesItem) {
    this.roles.add(rolesItem);
    return this;
  }

   /**
   * Roles of the user
   * @return roles
  **/
  @Schema(example = "[ROLE_RESEARCHER]", required = true, description = "Roles of the user")
  public List<String> getRoles() {
    return roles;
  }

  public void setRoles(List<String> roles) {
    this.roles = roles;
  }

  public UserDto containers(List<ContainerDto> containers) {
    this.containers = containers;
    return this;
  }

  public UserDto addContainersItem(ContainerDto containersItem) {
    if (this.containers == null) {
      this.containers = new ArrayList<ContainerDto>();
    }
    this.containers.add(containersItem);
    return this;
  }

   /**
   * Get containers
   * @return containers
  **/
  @Schema(description = "")
  public List<ContainerDto> getContainers() {
    return containers;
  }

  public void setContainers(List<ContainerDto> containers) {
    this.containers = containers;
  }

  public UserDto databases(List<ContainerDto> databases) {
    this.databases = databases;
    return this;
  }

  public UserDto addDatabasesItem(ContainerDto databasesItem) {
    if (this.databases == null) {
      this.databases = new ArrayList<ContainerDto>();
    }
    this.databases.add(databasesItem);
    return this;
  }

   /**
   * Get databases
   * @return databases
  **/
  @Schema(description = "")
  public List<ContainerDto> getDatabases() {
    return databases;
  }

  public void setDatabases(List<ContainerDto> databases) {
    this.databases = databases;
  }

  public UserDto identifiers(List<ContainerDto> identifiers) {
    this.identifiers = identifiers;
    return this;
  }

  public UserDto addIdentifiersItem(ContainerDto identifiersItem) {
    if (this.identifiers == null) {
      this.identifiers = new ArrayList<ContainerDto>();
    }
    this.identifiers.add(identifiersItem);
    return this;
  }

   /**
   * Get identifiers
   * @return identifiers
  **/
  @Schema(description = "")
  public List<ContainerDto> getIdentifiers() {
    return identifiers;
  }

  public void setIdentifiers(List<ContainerDto> identifiers) {
    this.identifiers = identifiers;
  }

  public UserDto email(String email) {
    this.email = email;
    return this;
  }

   /**
   * Get email
   * @return email
  **/
  @Schema(example = "jcarberry@brown.edu", required = true, description = "")
  public String getEmail() {
    return email;
  }

  public void setEmail(String email) {
    this.email = email;
  }

  public UserDto titlesBefore(String titlesBefore) {
    this.titlesBefore = titlesBefore;
    return this;
  }

   /**
   * Get titlesBefore
   * @return titlesBefore
  **/
  @Schema(example = "Prof.", description = "")
  public String getTitlesBefore() {
    return titlesBefore;
  }

  public void setTitlesBefore(String titlesBefore) {
    this.titlesBefore = titlesBefore;
  }

  public UserDto titlesAfter(String titlesAfter) {
    this.titlesAfter = titlesAfter;
    return this;
  }

   /**
   * Get titlesAfter
   * @return titlesAfter
  **/
  @Schema(description = "")
  public String getTitlesAfter() {
    return titlesAfter;
  }

  public void setTitlesAfter(String titlesAfter) {
    this.titlesAfter = titlesAfter;
  }

  public UserDto themeDark(Boolean themeDark) {
    this.themeDark = themeDark;
    return this;
  }

   /**
   * Get themeDark
   * @return themeDark
  **/
  @Schema(example = "true", required = true, description = "")
  public Boolean isThemeDark() {
    return themeDark;
  }

  public void setThemeDark(Boolean themeDark) {
    this.themeDark = themeDark;
  }

  public UserDto emailVerified(Boolean emailVerified) {
    this.emailVerified = emailVerified;
    return this;
  }

   /**
   * Get emailVerified
   * @return emailVerified
  **/
  @Schema(example = "true", required = true, description = "")
  public Boolean isEmailVerified() {
    return emailVerified;
  }

  public void setEmailVerified(Boolean emailVerified) {
    this.emailVerified = emailVerified;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserDto userDto = (UserDto) o;
    return Objects.equals(this.id, userDto.id) &&
        Objects.equals(this.authorities, userDto.authorities) &&
        Objects.equals(this.username, userDto.username) &&
        Objects.equals(this.firstname, userDto.firstname) &&
        Objects.equals(this.lastname, userDto.lastname) &&
        Objects.equals(this.affiliation, userDto.affiliation) &&
        Objects.equals(this.orcid, userDto.orcid) &&
        Objects.equals(this.roles, userDto.roles) &&
        Objects.equals(this.containers, userDto.containers) &&
        Objects.equals(this.databases, userDto.databases) &&
        Objects.equals(this.identifiers, userDto.identifiers) &&
        Objects.equals(this.email, userDto.email) &&
        Objects.equals(this.titlesBefore, userDto.titlesBefore) &&
        Objects.equals(this.titlesAfter, userDto.titlesAfter) &&
        Objects.equals(this.themeDark, userDto.themeDark) &&
        Objects.equals(this.emailVerified, userDto.emailVerified);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, authorities, username, firstname, lastname, affiliation, orcid, roles, containers, databases, identifiers, email, titlesBefore, titlesAfter, themeDark, emailVerified);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    authorities: ").append(toIndentedString(authorities)).append("\n");
    sb.append("    username: ").append(toIndentedString(username)).append("\n");
    sb.append("    firstname: ").append(toIndentedString(firstname)).append("\n");
    sb.append("    lastname: ").append(toIndentedString(lastname)).append("\n");
    sb.append("    affiliation: ").append(toIndentedString(affiliation)).append("\n");
    sb.append("    orcid: ").append(toIndentedString(orcid)).append("\n");
    sb.append("    roles: ").append(toIndentedString(roles)).append("\n");
    sb.append("    containers: ").append(toIndentedString(containers)).append("\n");
    sb.append("    databases: ").append(toIndentedString(databases)).append("\n");
    sb.append("    identifiers: ").append(toIndentedString(identifiers)).append("\n");
    sb.append("    email: ").append(toIndentedString(email)).append("\n");
    sb.append("    titlesBefore: ").append(toIndentedString(titlesBefore)).append("\n");
    sb.append("    titlesAfter: ").append(toIndentedString(titlesAfter)).append("\n");
    sb.append("    themeDark: ").append(toIndentedString(themeDark)).append("\n");
    sb.append("    emailVerified: ").append(toIndentedString(emailVerified)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
