/*
 * Database Repository Query Service API
 * Service that manages the queries
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import org.threeten.bp.OffsetDateTime;
/**
 * ViewBriefDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T12:27:08.557443+01:00[Europe/Vienna]")
public class ViewBriefDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("vdbid")
  private Long vdbid = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("internalName")
  private String internalName = null;

  @SerializedName("query")
  private String query = null;

  @SerializedName("created")
  private OffsetDateTime created = null;

  @SerializedName("is_public")
  private Boolean isPublic = null;

  @SerializedName("initial_view")
  private Boolean initialView = null;

  @SerializedName("created_by")
  private Long createdBy = null;

  @SerializedName("last_modified")
  private OffsetDateTime lastModified = null;

  public ViewBriefDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public ViewBriefDto vdbid(Long vdbid) {
    this.vdbid = vdbid;
    return this;
  }

   /**
   * Get vdbid
   * @return vdbid
  **/
  @Schema(required = true, description = "")
  public Long getVdbid() {
    return vdbid;
  }

  public void setVdbid(Long vdbid) {
    this.vdbid = vdbid;
  }

  public ViewBriefDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @Schema(example = "Air Quality", required = true, description = "")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ViewBriefDto internalName(String internalName) {
    this.internalName = internalName;
    return this;
  }

   /**
   * Get internalName
   * @return internalName
  **/
  @Schema(example = "air_quality", required = true, description = "")
  public String getInternalName() {
    return internalName;
  }

  public void setInternalName(String internalName) {
    this.internalName = internalName;
  }

  public ViewBriefDto query(String query) {
    this.query = query;
    return this;
  }

   /**
   * Get query
   * @return query
  **/
  @Schema(example = "SELECT `id` FROM `air_quality` ORDER BY `value` DESC", required = true, description = "")
  public String getQuery() {
    return query;
  }

  public void setQuery(String query) {
    this.query = query;
  }

  public ViewBriefDto created(OffsetDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @Schema(required = true, description = "")
  public OffsetDateTime getCreated() {
    return created;
  }

  public void setCreated(OffsetDateTime created) {
    this.created = created;
  }

  public ViewBriefDto isPublic(Boolean isPublic) {
    this.isPublic = isPublic;
    return this;
  }

   /**
   * Get isPublic
   * @return isPublic
  **/
  @Schema(example = "true", description = "")
  public Boolean isIsPublic() {
    return isPublic;
  }

  public void setIsPublic(Boolean isPublic) {
    this.isPublic = isPublic;
  }

  public ViewBriefDto initialView(Boolean initialView) {
    this.initialView = initialView;
    return this;
  }

   /**
   * True if it is the default view for the database
   * @return initialView
  **/
  @Schema(example = "true", description = "True if it is the default view for the database")
  public Boolean isInitialView() {
    return initialView;
  }

  public void setInitialView(Boolean initialView) {
    this.initialView = initialView;
  }

  public ViewBriefDto createdBy(Long createdBy) {
    this.createdBy = createdBy;
    return this;
  }

   /**
   * Get createdBy
   * @return createdBy
  **/
  @Schema(required = true, description = "")
  public Long getCreatedBy() {
    return createdBy;
  }

  public void setCreatedBy(Long createdBy) {
    this.createdBy = createdBy;
  }

  public ViewBriefDto lastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
    return this;
  }

   /**
   * Get lastModified
   * @return lastModified
  **/
  @Schema(description = "")
  public OffsetDateTime getLastModified() {
    return lastModified;
  }

  public void setLastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ViewBriefDto viewBriefDto = (ViewBriefDto) o;
    return Objects.equals(this.id, viewBriefDto.id) &&
        Objects.equals(this.vdbid, viewBriefDto.vdbid) &&
        Objects.equals(this.name, viewBriefDto.name) &&
        Objects.equals(this.internalName, viewBriefDto.internalName) &&
        Objects.equals(this.query, viewBriefDto.query) &&
        Objects.equals(this.created, viewBriefDto.created) &&
        Objects.equals(this.isPublic, viewBriefDto.isPublic) &&
        Objects.equals(this.initialView, viewBriefDto.initialView) &&
        Objects.equals(this.createdBy, viewBriefDto.createdBy) &&
        Objects.equals(this.lastModified, viewBriefDto.lastModified);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, vdbid, name, internalName, query, created, isPublic, initialView, createdBy, lastModified);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ViewBriefDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    vdbid: ").append(toIndentedString(vdbid)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    internalName: ").append(toIndentedString(internalName)).append("\n");
    sb.append("    query: ").append(toIndentedString(query)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    isPublic: ").append(toIndentedString(isPublic)).append("\n");
    sb.append("    initialView: ").append(toIndentedString(initialView)).append("\n");
    sb.append("    createdBy: ").append(toIndentedString(createdBy)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
