/*
 * Database Repository Query Service API
 * Service that manages the queries
 *
 * OpenAPI spec version: 1.1.0-alpha
 * Contact: andreas.rauber@tuwien.ac.at
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.DatabaseDto;
import io.swagger.client.model.UserDto;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import org.threeten.bp.OffsetDateTime;
/**
 * ViewDto
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-02-12T12:27:08.557443+01:00[Europe/Vienna]")
public class ViewDto {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("vdbid")
  private Long vdbid = null;

  @SerializedName("creator")
  private UserDto creator = null;

  @SerializedName("database")
  private DatabaseDto database = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("internalName")
  private String internalName = null;

  @SerializedName("query")
  private String query = null;

  @SerializedName("created")
  private OffsetDateTime created = null;

  @SerializedName("is_public")
  private Boolean isPublic = null;

  @SerializedName("initial_view")
  private Boolean initialView = null;

  @SerializedName("last_modified")
  private OffsetDateTime lastModified = null;

  public ViewDto id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(required = true, description = "")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public ViewDto vdbid(Long vdbid) {
    this.vdbid = vdbid;
    return this;
  }

   /**
   * Get vdbid
   * @return vdbid
  **/
  @Schema(required = true, description = "")
  public Long getVdbid() {
    return vdbid;
  }

  public void setVdbid(Long vdbid) {
    this.vdbid = vdbid;
  }

  public ViewDto creator(UserDto creator) {
    this.creator = creator;
    return this;
  }

   /**
   * Get creator
   * @return creator
  **/
  @Schema(required = true, description = "")
  public UserDto getCreator() {
    return creator;
  }

  public void setCreator(UserDto creator) {
    this.creator = creator;
  }

  public ViewDto database(DatabaseDto database) {
    this.database = database;
    return this;
  }

   /**
   * Get database
   * @return database
  **/
  @Schema(required = true, description = "")
  public DatabaseDto getDatabase() {
    return database;
  }

  public void setDatabase(DatabaseDto database) {
    this.database = database;
  }

  public ViewDto name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @Schema(example = "Air Quality", required = true, description = "")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ViewDto internalName(String internalName) {
    this.internalName = internalName;
    return this;
  }

   /**
   * Get internalName
   * @return internalName
  **/
  @Schema(example = "air_quality", required = true, description = "")
  public String getInternalName() {
    return internalName;
  }

  public void setInternalName(String internalName) {
    this.internalName = internalName;
  }

  public ViewDto query(String query) {
    this.query = query;
    return this;
  }

   /**
   * Get query
   * @return query
  **/
  @Schema(example = "SELECT `id` FROM `air_quality` ORDER BY `value` DESC", required = true, description = "")
  public String getQuery() {
    return query;
  }

  public void setQuery(String query) {
    this.query = query;
  }

  public ViewDto created(OffsetDateTime created) {
    this.created = created;
    return this;
  }

   /**
   * Get created
   * @return created
  **/
  @Schema(required = true, description = "")
  public OffsetDateTime getCreated() {
    return created;
  }

  public void setCreated(OffsetDateTime created) {
    this.created = created;
  }

  public ViewDto isPublic(Boolean isPublic) {
    this.isPublic = isPublic;
    return this;
  }

   /**
   * Get isPublic
   * @return isPublic
  **/
  @Schema(example = "true", description = "")
  public Boolean isIsPublic() {
    return isPublic;
  }

  public void setIsPublic(Boolean isPublic) {
    this.isPublic = isPublic;
  }

  public ViewDto initialView(Boolean initialView) {
    this.initialView = initialView;
    return this;
  }

   /**
   * True if it is the default view for the database
   * @return initialView
  **/
  @Schema(example = "true", description = "True if it is the default view for the database")
  public Boolean isInitialView() {
    return initialView;
  }

  public void setInitialView(Boolean initialView) {
    this.initialView = initialView;
  }

  public ViewDto lastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
    return this;
  }

   /**
   * Get lastModified
   * @return lastModified
  **/
  @Schema(description = "")
  public OffsetDateTime getLastModified() {
    return lastModified;
  }

  public void setLastModified(OffsetDateTime lastModified) {
    this.lastModified = lastModified;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ViewDto viewDto = (ViewDto) o;
    return Objects.equals(this.id, viewDto.id) &&
        Objects.equals(this.vdbid, viewDto.vdbid) &&
        Objects.equals(this.creator, viewDto.creator) &&
        Objects.equals(this.database, viewDto.database) &&
        Objects.equals(this.name, viewDto.name) &&
        Objects.equals(this.internalName, viewDto.internalName) &&
        Objects.equals(this.query, viewDto.query) &&
        Objects.equals(this.created, viewDto.created) &&
        Objects.equals(this.isPublic, viewDto.isPublic) &&
        Objects.equals(this.initialView, viewDto.initialView) &&
        Objects.equals(this.lastModified, viewDto.lastModified);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, vdbid, creator, database, name, internalName, query, created, isPublic, initialView, lastModified);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ViewDto {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    vdbid: ").append(toIndentedString(vdbid)).append("\n");
    sb.append("    creator: ").append(toIndentedString(creator)).append("\n");
    sb.append("    database: ").append(toIndentedString(database)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    internalName: ").append(toIndentedString(internalName)).append("\n");
    sb.append("    query: ").append(toIndentedString(query)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    isPublic: ").append(toIndentedString(isPublic)).append("\n");
    sb.append("    initialView: ").append(toIndentedString(initialView)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
