package at.tuwien.mapper;

import at.tuwien.BaseUnitTest;
import at.tuwien.config.IndexConfig;
import at.tuwien.config.ReadyConfig;
import at.tuwien.entities.container.image.ContainerImageDate;
import at.tuwien.entities.database.table.columns.TableColumn;
import at.tuwien.entities.database.table.columns.TableColumnType;
import at.tuwien.listener.impl.RabbitMqListenerImpl;
import com.rabbitmq.client.Channel;
import lombok.extern.log4j.Log4j2;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import java.time.Instant;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.Mockito.doReturn;

@Log4j2
@SpringBootTest
@ExtendWith(SpringExtension.class)
public class QueryMapperTest extends BaseUnitTest {

    @MockBean
    private ReadyConfig readyConfig;

    @MockBean
    private Channel channel;

    @MockBean
    private IndexConfig indexInitializer;

    @MockBean
    private RabbitMqListenerImpl rabbitMqListener;

    @Autowired
    private QueryMapper queryMapper;

    @Test
    public void dataColumnToObject_succeeds() {
        final TableColumn request = TableColumn.builder()
                .id(1L)
                .cdbid(DATABASE_1_ID)
                .dfid(1L)
                .autoGenerated(false)
                .columnType(TableColumnType.TIMESTAMP)
                .internalName("date")
                .name("Date")
                .dateFormat(ContainerImageDate.builder().build())
                .table(TABLE_1)
                .build();

        /* mock */

        /* test */
        final Object response = queryMapper.dataColumnToObject("2022-05-12 14:50:54.0", request);
        assertEquals(Instant.ofEpochSecond(1652359854), (Instant) response);
    }

}
