package at.tuwien.service;

import at.tuwien.entities.database.Database;
import at.tuwien.exception.*;

import java.security.Principal;

public interface DatabaseService {

    /**
     * Finds a specific database for a given id in the metadata database.
     *
     * @param containerId The container id.
     * @param databaseId  The database id.
     * @return The database if found.
     * @throws DatabaseNotFoundException The database was not found.
     */
    Database find(Long containerId, Long databaseId) throws DatabaseNotFoundException;
}
